/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "/build/zeek/src/zeek/src/parse.y"

// See the file "COPYING" in the main distribution directory for copyright.
#line 84 "/build/zeek/src/zeek/src/parse.y"

#include <cstdlib>
#include <cstring>
#include <cassert>

#include <set>
#include <string>

#include "zeek/input.h"
#include "zeek/ZeekList.h"
#include "zeek/Desc.h"
#include "zeek/Expr.h"
#include "zeek/Func.h"
#include "zeek/Stmt.h"
#include "zeek/Val.h"
#include "zeek/Var.h"
#include "zeek/RE.h"
#include "zeek/Scope.h"
#include "zeek/Reporter.h"
#include "zeek/ScriptCoverageManager.h"
#include "zeek/ScriptValidation.h"
#include "zeek/zeekygen/Manager.h"
#include "zeek/module_util.h"
#include "zeek/IntrusivePtr.h"

extern const char* filename;  // Absolute path of file currently being parsed.
extern const char* last_filename; // Absolute path of last file parsed.
extern const char* last_tok_filename;
extern const char* last_last_tok_filename;

extern int conditional_epoch; // let's us track embedded conditionals

// Whether the file we're currently parsing includes @if conditionals.
extern bool current_file_has_conditionals;

extern YYLTYPE GetCurrentLocation();
extern int yyerror(const char[]);
extern int zeeklex();

#define YYLLOC_DEFAULT(Current, Rhs, N) \
	(Current) = (Rhs)[(N)];

using namespace zeek;
using namespace zeek::detail;

// Part of the module facility: while parsing, keep track of which
// module to put things in.
std::string zeek::detail::current_module = GLOBAL_MODULE_NAME;

bool is_export = false; // true if in an export {} block

// Used to temporarily turn off "is_export". A stack because the need
// to do so can nest.
std::vector<bool> hold_is_export;

// When parsing an expression for the debugger, where to put the result
// (obviously not reentrant).
extern Expr* g_curr_debug_expr;
extern bool in_debug;
extern const char* g_curr_debug_error;

extern int in_when_cond;

static int in_hook = 0;
int in_init = 0;
int in_record = 0;
static int in_record_redef = 0;
static int in_enum_redef = 0;
bool resolving_global_ID = false;
bool defining_global_ID = false;
std::vector<int> saved_in_init;
static int expr_list_has_opt_comma = 0;

std::vector<std::set<const ID*>> locals_at_this_scope;
static std::unordered_set<const ID*> out_of_scope_locals;

static Location func_hdr_location;
static int func_hdr_cond_epoch = 0;
EnumType* cur_enum_type = nullptr;
static ID* cur_decl_type_id = nullptr;

static void parse_new_enum(void)
	{
	// Starting a new enum definition.
	assert(cur_enum_type == nullptr);

	if ( cur_decl_type_id )
		{
		auto name = make_full_var_name(current_module.c_str(), cur_decl_type_id->Name());
		cur_enum_type = new EnumType(name);
		}
	else
		reporter->FatalError("incorrect syntax for enum type declaration");
	}

static void parse_redef_enum(ID* id)
	{
	// Redef an enum. id points to the enum to be redefined.
	// Let cur_enum_type point to it.
	assert(cur_enum_type == nullptr);

	// abort on errors; enums need to be accessible to continue parsing
	if ( ! id->GetType() )
		reporter->FatalError("unknown enum identifier \"%s\"", id->Name());
	else
		{
		if ( ! id->GetType() || id->GetType()->Tag() != TYPE_ENUM )
			reporter->FatalError("identifier \"%s\" is not an enum", id->Name());
		cur_enum_type = id->GetType()->AsEnumType();
		}
	}

static void parse_redef_record_field(ID* id, const char* field, InitClass ic,
                                     std::unique_ptr<std::vector<AttrPtr>> attrs)
	{
	if ( ! id->GetType() )
		{
		reporter->FatalError("unknown record identifier \"%s\"", id->Name());
		return;
		}

	auto t = id->GetType();
	if ( ! t || t->Tag() != TYPE_RECORD )
		{
		reporter->FatalError("identifier \"%s\" has type \"%s\", expected \"record\"",
		                     id->Name(), type_name(t->Tag()));
		return;
		}

	auto rt = t->AsRecordType();
	auto idx = rt->FieldOffset(field);
	if ( idx < 0 )
		{
		reporter->FatalError("field \"%s\" not in record \"%s\"", field, id->Name());
		return;
		}

	auto decl = rt->FieldDecl(idx);
	if ( ! decl->attrs )
		if ( ic == INIT_EXTRA )
			decl->attrs = make_intrusive<detail::Attributes>(decl->type,
			                                                 true /* in_record */,
			                                                 false /* is_global */);

	for ( const auto& attr : *attrs )
		{
		// At this point, only support &log redef'ing.
		if ( attr->Tag() != ATTR_LOG )
			{
				reporter->FatalError("Can only redef \"&log\" attributes of record fields");
				return;
			}

		if ( ic == INIT_EXTRA )
			decl->attrs->AddAttr(attr, true /* is_redef */);
		else
			// Removing attributes is a noop if they don't exist.
			if ( decl->attrs )
				decl->attrs->RemoveAttr(attr->Tag());
		}
	}

static void extend_record(ID* id, std::unique_ptr<type_decl_list> fields,
                          std::unique_ptr<std::vector<AttrPtr>> attrs)
	{
	const auto& types = Type::Aliases(id->Name());

	if ( types.empty() )
		{
		id->Error("failed to redef record: no types found in alias map");
		return;
		}

	bool add_log_attr = false;

	if ( attrs )
		for ( const auto& at : *attrs )
			if ( at->Tag() == ATTR_LOG )
				{
				add_log_attr = true;
				break;
				}

	for ( const auto& t : types )
		{
		auto error = t->AsRecordType()->AddFields(*fields, add_log_attr);

		if ( error )
			{
			id->Error(error);
			break;
			}
		}
	}

static AttributesPtr
make_attributes(std::vector<AttrPtr>* attrs,
                TypePtr t, bool in_record, bool is_global)
	{
	if ( ! attrs )
		return nullptr;

	auto rval = make_intrusive<Attributes>(std::move(*attrs), std::move(t),
	                                       in_record, is_global);
	delete attrs;
	return rval;
	}

static bool expr_is_table_type_name(const Expr* expr)
	{
	if ( expr->Tag() != EXPR_NAME )
		return false;

	const auto& type = expr->GetType();

	if ( type->IsTable() )
		return true;

	if ( type->Tag() == TYPE_TYPE )
		return type->AsTypeType()->GetType()->IsTable();

	return false;
	}

static void check_loop_var(const IDPtr& var)
	{
	if ( var->IsGlobal() )
 		var->Error("global variable used in 'for' loop");

 	if ( var->IsConst() )
 		var->Error("constant used in 'for' loop");
	}

static void build_global(ID* id, Type* t, InitClass ic, Expr* e,
                         std::vector<AttrPtr>* attrs, DeclType dt)
	{
	IDPtr id_ptr{AdoptRef{}, id};
	TypePtr t_ptr{AdoptRef{}, t};
	ExprPtr e_ptr{AdoptRef{}, e};

	auto attrs_ptr = attrs ? std::make_unique<std::vector<AttrPtr>>(*attrs) : nullptr;

	add_global(id_ptr, std::move(t_ptr), ic, e_ptr, std::move(attrs_ptr), dt);

	if ( dt == VAR_REDEF )
		zeekygen_mgr->Redef(id, ::filename, ic, std::move(e_ptr));
	else
		zeekygen_mgr->Identifier(std::move(id_ptr));
	}

static StmtPtr build_local(ID* id, Type* t, InitClass ic, Expr* e,
                           std::vector<AttrPtr>* attrs, DeclType dt,
                           bool do_coverage)
	{
	IDPtr id_ptr{AdoptRef{}, id};
	TypePtr t_ptr{AdoptRef{}, t};
	ExprPtr e_ptr{AdoptRef{}, e};

	auto attrs_ptr = attrs ? std::make_unique<std::vector<AttrPtr>>(*attrs) : nullptr;

	auto init = add_local(std::move(id_ptr), std::move(t_ptr), ic,
	                      e_ptr, std::move(attrs_ptr), dt);

	if ( do_coverage )
		script_coverage_mgr.AddStmt(init.get());

	return init;
	}

static void refine_location(zeek::detail::ID* id)
	{
	if ( *id->GetLocationInfo() == zeek::detail::no_location )
		id->SetLocationInfo(&detail::start_location, &detail::end_location);
	}


#line 351 "/build/zeek/src/zeek/build/src/p.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "zeekparse.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOK_ADD = 3,                    /* TOK_ADD  */
  YYSYMBOL_TOK_ADD_TO = 4,                 /* TOK_ADD_TO  */
  YYSYMBOL_TOK_ADDR = 5,                   /* TOK_ADDR  */
  YYSYMBOL_TOK_ANY = 6,                    /* TOK_ANY  */
  YYSYMBOL_TOK_ASSERT = 7,                 /* TOK_ASSERT  */
  YYSYMBOL_TOK_ATENDIF = 8,                /* TOK_ATENDIF  */
  YYSYMBOL_TOK_ATELSE = 9,                 /* TOK_ATELSE  */
  YYSYMBOL_TOK_ATIF = 10,                  /* TOK_ATIF  */
  YYSYMBOL_TOK_ATIFDEF = 11,               /* TOK_ATIFDEF  */
  YYSYMBOL_TOK_ATIFNDEF = 12,              /* TOK_ATIFNDEF  */
  YYSYMBOL_TOK_BOOL = 13,                  /* TOK_BOOL  */
  YYSYMBOL_TOK_BREAK = 14,                 /* TOK_BREAK  */
  YYSYMBOL_TOK_CASE = 15,                  /* TOK_CASE  */
  YYSYMBOL_TOK_OPTION = 16,                /* TOK_OPTION  */
  YYSYMBOL_TOK_CONST = 17,                 /* TOK_CONST  */
  YYSYMBOL_TOK_CONSTANT = 18,              /* TOK_CONSTANT  */
  YYSYMBOL_TOK_COPY = 19,                  /* TOK_COPY  */
  YYSYMBOL_TOK_COUNT = 20,                 /* TOK_COUNT  */
  YYSYMBOL_TOK_DEFAULT = 21,               /* TOK_DEFAULT  */
  YYSYMBOL_TOK_DELETE = 22,                /* TOK_DELETE  */
  YYSYMBOL_TOK_DOUBLE = 23,                /* TOK_DOUBLE  */
  YYSYMBOL_TOK_ELSE = 24,                  /* TOK_ELSE  */
  YYSYMBOL_TOK_ENUM = 25,                  /* TOK_ENUM  */
  YYSYMBOL_TOK_EVENT = 26,                 /* TOK_EVENT  */
  YYSYMBOL_TOK_EXPORT = 27,                /* TOK_EXPORT  */
  YYSYMBOL_TOK_FALLTHROUGH = 28,           /* TOK_FALLTHROUGH  */
  YYSYMBOL_TOK_FILE = 29,                  /* TOK_FILE  */
  YYSYMBOL_TOK_FOR = 30,                   /* TOK_FOR  */
  YYSYMBOL_TOK_FUNCTION = 31,              /* TOK_FUNCTION  */
  YYSYMBOL_TOK_GLOBAL = 32,                /* TOK_GLOBAL  */
  YYSYMBOL_TOK_HOOK = 33,                  /* TOK_HOOK  */
  YYSYMBOL_TOK_ID = 34,                    /* TOK_ID  */
  YYSYMBOL_TOK_IF = 35,                    /* TOK_IF  */
  YYSYMBOL_TOK_INT = 36,                   /* TOK_INT  */
  YYSYMBOL_TOK_INTERVAL = 37,              /* TOK_INTERVAL  */
  YYSYMBOL_TOK_LIST = 38,                  /* TOK_LIST  */
  YYSYMBOL_TOK_MODULE = 39,                /* TOK_MODULE  */
  YYSYMBOL_TOK_LOCAL = 40,                 /* TOK_LOCAL  */
  YYSYMBOL_TOK_WHEN_LOCAL = 41,            /* TOK_WHEN_LOCAL  */
  YYSYMBOL_TOK_NEXT = 42,                  /* TOK_NEXT  */
  YYSYMBOL_TOK_OF = 43,                    /* TOK_OF  */
  YYSYMBOL_TOK_OPAQUE = 44,                /* TOK_OPAQUE  */
  YYSYMBOL_TOK_PATTERN = 45,               /* TOK_PATTERN  */
  YYSYMBOL_TOK_PATTERN_END = 46,           /* TOK_PATTERN_END  */
  YYSYMBOL_TOK_PATTERN_TEXT = 47,          /* TOK_PATTERN_TEXT  */
  YYSYMBOL_TOK_PORT = 48,                  /* TOK_PORT  */
  YYSYMBOL_TOK_PRINT = 49,                 /* TOK_PRINT  */
  YYSYMBOL_TOK_RECORD = 50,                /* TOK_RECORD  */
  YYSYMBOL_TOK_REDEF = 51,                 /* TOK_REDEF  */
  YYSYMBOL_TOK_REMOVE_FROM = 52,           /* TOK_REMOVE_FROM  */
  YYSYMBOL_TOK_RETURN = 53,                /* TOK_RETURN  */
  YYSYMBOL_TOK_SCHEDULE = 54,              /* TOK_SCHEDULE  */
  YYSYMBOL_TOK_SET = 55,                   /* TOK_SET  */
  YYSYMBOL_TOK_STRING = 56,                /* TOK_STRING  */
  YYSYMBOL_TOK_SUBNET = 57,                /* TOK_SUBNET  */
  YYSYMBOL_TOK_SWITCH = 58,                /* TOK_SWITCH  */
  YYSYMBOL_TOK_TABLE = 59,                 /* TOK_TABLE  */
  YYSYMBOL_TOK_TIME = 60,                  /* TOK_TIME  */
  YYSYMBOL_TOK_TIMEOUT = 61,               /* TOK_TIMEOUT  */
  YYSYMBOL_TOK_TYPE = 62,                  /* TOK_TYPE  */
  YYSYMBOL_TOK_VECTOR = 63,                /* TOK_VECTOR  */
  YYSYMBOL_TOK_WHEN = 64,                  /* TOK_WHEN  */
  YYSYMBOL_TOK_WHILE = 65,                 /* TOK_WHILE  */
  YYSYMBOL_TOK_AS = 66,                    /* TOK_AS  */
  YYSYMBOL_TOK_IS = 67,                    /* TOK_IS  */
  YYSYMBOL_TOK_GLOBAL_ID = 68,             /* TOK_GLOBAL_ID  */
  YYSYMBOL_TOK_ATTR_ADD_FUNC = 69,         /* TOK_ATTR_ADD_FUNC  */
  YYSYMBOL_TOK_ATTR_DEFAULT = 70,          /* TOK_ATTR_DEFAULT  */
  YYSYMBOL_TOK_ATTR_DEFAULT_INSERT = 71,   /* TOK_ATTR_DEFAULT_INSERT  */
  YYSYMBOL_TOK_ATTR_OPTIONAL = 72,         /* TOK_ATTR_OPTIONAL  */
  YYSYMBOL_TOK_ATTR_REDEF = 73,            /* TOK_ATTR_REDEF  */
  YYSYMBOL_TOK_ATTR_DEL_FUNC = 74,         /* TOK_ATTR_DEL_FUNC  */
  YYSYMBOL_TOK_ATTR_EXPIRE_FUNC = 75,      /* TOK_ATTR_EXPIRE_FUNC  */
  YYSYMBOL_TOK_ATTR_EXPIRE_CREATE = 76,    /* TOK_ATTR_EXPIRE_CREATE  */
  YYSYMBOL_TOK_ATTR_EXPIRE_READ = 77,      /* TOK_ATTR_EXPIRE_READ  */
  YYSYMBOL_TOK_ATTR_EXPIRE_WRITE = 78,     /* TOK_ATTR_EXPIRE_WRITE  */
  YYSYMBOL_TOK_ATTR_RAW_OUTPUT = 79,       /* TOK_ATTR_RAW_OUTPUT  */
  YYSYMBOL_TOK_ATTR_ON_CHANGE = 80,        /* TOK_ATTR_ON_CHANGE  */
  YYSYMBOL_TOK_ATTR_BROKER_STORE = 81,     /* TOK_ATTR_BROKER_STORE  */
  YYSYMBOL_TOK_ATTR_BROKER_STORE_ALLOW_COMPLEX = 82, /* TOK_ATTR_BROKER_STORE_ALLOW_COMPLEX  */
  YYSYMBOL_TOK_ATTR_BACKEND = 83,          /* TOK_ATTR_BACKEND  */
  YYSYMBOL_TOK_ATTR_PRIORITY = 84,         /* TOK_ATTR_PRIORITY  */
  YYSYMBOL_TOK_ATTR_LOG = 85,              /* TOK_ATTR_LOG  */
  YYSYMBOL_TOK_ATTR_ERROR_HANDLER = 86,    /* TOK_ATTR_ERROR_HANDLER  */
  YYSYMBOL_TOK_ATTR_GROUP = 87,            /* TOK_ATTR_GROUP  */
  YYSYMBOL_TOK_ATTR_TYPE_COLUMN = 88,      /* TOK_ATTR_TYPE_COLUMN  */
  YYSYMBOL_TOK_ATTR_DEPRECATED = 89,       /* TOK_ATTR_DEPRECATED  */
  YYSYMBOL_TOK_ATTR_IS_ASSIGNED = 90,      /* TOK_ATTR_IS_ASSIGNED  */
  YYSYMBOL_TOK_ATTR_IS_USED = 91,          /* TOK_ATTR_IS_USED  */
  YYSYMBOL_TOK_ATTR_ORDERED = 92,          /* TOK_ATTR_ORDERED  */
  YYSYMBOL_TOK_DEBUG = 93,                 /* TOK_DEBUG  */
  YYSYMBOL_TOK_NO_TEST = 94,               /* TOK_NO_TEST  */
  YYSYMBOL_95_ = 95,                       /* ','  */
  YYSYMBOL_96_ = 96,                       /* '='  */
  YYSYMBOL_97_ = 97,                       /* '?'  */
  YYSYMBOL_98_ = 98,                       /* ':'  */
  YYSYMBOL_TOK_OR_OR = 99,                 /* TOK_OR_OR  */
  YYSYMBOL_TOK_AND_AND = 100,              /* TOK_AND_AND  */
  YYSYMBOL_101_ = 101,                     /* '<'  */
  YYSYMBOL_102_ = 102,                     /* '>'  */
  YYSYMBOL_TOK_LE = 103,                   /* TOK_LE  */
  YYSYMBOL_TOK_GE = 104,                   /* TOK_GE  */
  YYSYMBOL_TOK_EQ = 105,                   /* TOK_EQ  */
  YYSYMBOL_TOK_NE = 106,                   /* TOK_NE  */
  YYSYMBOL_TOK_IN = 107,                   /* TOK_IN  */
  YYSYMBOL_TOK_NOT_IN = 108,               /* TOK_NOT_IN  */
  YYSYMBOL_109_ = 109,                     /* '|'  */
  YYSYMBOL_110_ = 110,                     /* '^'  */
  YYSYMBOL_111_ = 111,                     /* '&'  */
  YYSYMBOL_TOK_LSHIFT = 112,               /* TOK_LSHIFT  */
  YYSYMBOL_TOK_RSHIFT = 113,               /* TOK_RSHIFT  */
  YYSYMBOL_114_ = 114,                     /* '+'  */
  YYSYMBOL_115_ = 115,                     /* '-'  */
  YYSYMBOL_116_ = 116,                     /* '*'  */
  YYSYMBOL_117_ = 117,                     /* '/'  */
  YYSYMBOL_118_ = 118,                     /* '%'  */
  YYSYMBOL_TOK_INCR = 119,                 /* TOK_INCR  */
  YYSYMBOL_TOK_DECR = 120,                 /* TOK_DECR  */
  YYSYMBOL_121_ = 121,                     /* '!'  */
  YYSYMBOL_122_ = 122,                     /* '~'  */
  YYSYMBOL_123_ = 123,                     /* '$'  */
  YYSYMBOL_124_ = 124,                     /* '['  */
  YYSYMBOL_125_ = 125,                     /* ']'  */
  YYSYMBOL_126_ = 126,                     /* '('  */
  YYSYMBOL_127_ = 127,                     /* ')'  */
  YYSYMBOL_TOK_HAS_FIELD = 128,            /* TOK_HAS_FIELD  */
  YYSYMBOL_TOK_HAS_ATTR = 129,             /* TOK_HAS_ATTR  */
  YYSYMBOL_130_ = 130,                     /* '{'  */
  YYSYMBOL_131_ = 131,                     /* '}'  */
  YYSYMBOL_132_ = 132,                     /* ';'  */
  YYSYMBOL_YYACCEPT = 133,                 /* $accept  */
  YYSYMBOL_zeek = 134,                     /* zeek  */
  YYSYMBOL_135_1 = 135,                    /* $@1  */
  YYSYMBOL_136_2 = 136,                    /* $@2  */
  YYSYMBOL_decl_list = 137,                /* decl_list  */
  YYSYMBOL_opt_expr = 138,                 /* opt_expr  */
  YYSYMBOL_when_clause = 139,              /* when_clause  */
  YYSYMBOL_when_head = 140,                /* when_head  */
  YYSYMBOL_when_start = 141,               /* when_start  */
  YYSYMBOL_when_flavor = 142,              /* when_flavor  */
  YYSYMBOL_when_captures = 143,            /* when_captures  */
  YYSYMBOL_when_condition = 144,           /* when_condition  */
  YYSYMBOL_145_3 = 145,                    /* $@3  */
  YYSYMBOL_146_4 = 146,                    /* $@4  */
  YYSYMBOL_expr = 147,                     /* expr  */
  YYSYMBOL_148_5 = 148,                    /* $@5  */
  YYSYMBOL_149_6 = 149,                    /* $@6  */
  YYSYMBOL_150_7 = 150,                    /* $@7  */
  YYSYMBOL_151_8 = 151,                    /* $@8  */
  YYSYMBOL_152_9 = 152,                    /* $@9  */
  YYSYMBOL_153_10 = 153,                   /* $@10  */
  YYSYMBOL_154_11 = 154,                   /* $@11  */
  YYSYMBOL_155_12 = 155,                   /* $@12  */
  YYSYMBOL_rhs = 156,                      /* rhs  */
  YYSYMBOL_157_13 = 157,                   /* $@13  */
  YYSYMBOL_rhs_expr_list = 158,            /* rhs_expr_list  */
  YYSYMBOL_expr_list = 159,                /* expr_list  */
  YYSYMBOL_opt_expr_list = 160,            /* opt_expr_list  */
  YYSYMBOL_enum_body = 161,                /* enum_body  */
  YYSYMBOL_enum_body_list = 162,           /* enum_body_list  */
  YYSYMBOL_enum_body_elem = 163,           /* enum_body_elem  */
  YYSYMBOL_simple_type = 164,              /* simple_type  */
  YYSYMBOL_165_14 = 165,                   /* $@14  */
  YYSYMBOL_166_15 = 166,                   /* $@15  */
  YYSYMBOL_167_16 = 167,                   /* $@16  */
  YYSYMBOL_type = 168,                     /* type  */
  YYSYMBOL_type_list = 169,                /* type_list  */
  YYSYMBOL_type_decl_list = 170,           /* type_decl_list  */
  YYSYMBOL_type_decl = 171,                /* type_decl  */
  YYSYMBOL_formal_args = 172,              /* formal_args  */
  YYSYMBOL_formal_args_decl_list = 173,    /* formal_args_decl_list  */
  YYSYMBOL_formal_args_decl = 174,         /* formal_args_decl  */
  YYSYMBOL_decl = 175,                     /* decl  */
  YYSYMBOL_176_17 = 176,                   /* $@17  */
  YYSYMBOL_177_18 = 177,                   /* $@18  */
  YYSYMBOL_178_19 = 178,                   /* $@19  */
  YYSYMBOL_179_20 = 179,                   /* $@20  */
  YYSYMBOL_180_21 = 180,                   /* $@21  */
  YYSYMBOL_181_22 = 181,                   /* $@22  */
  YYSYMBOL_182_23 = 182,                   /* $@23  */
  YYSYMBOL_183_24 = 183,                   /* $@24  */
  YYSYMBOL_184_25 = 184,                   /* $@25  */
  YYSYMBOL_185_26 = 185,                   /* $@26  */
  YYSYMBOL_conditional_list = 186,         /* conditional_list  */
  YYSYMBOL_conditional = 187,              /* conditional  */
  YYSYMBOL_func_hdr = 188,                 /* func_hdr  */
  YYSYMBOL_func_body = 189,                /* func_body  */
  YYSYMBOL_190_27 = 190,                   /* $@27  */
  YYSYMBOL_191_28 = 191,                   /* $@28  */
  YYSYMBOL_lambda_body = 192,              /* lambda_body  */
  YYSYMBOL_193_29 = 193,                   /* $@29  */
  YYSYMBOL_194_30 = 194,                   /* $@30  */
  YYSYMBOL_anonymous_function = 195,       /* anonymous_function  */
  YYSYMBOL_196_31 = 196,                   /* $@31  */
  YYSYMBOL_begin_lambda = 197,             /* begin_lambda  */
  YYSYMBOL_opt_captures = 198,             /* opt_captures  */
  YYSYMBOL_capture_list = 199,             /* capture_list  */
  YYSYMBOL_capture = 200,                  /* capture  */
  YYSYMBOL_opt_deep = 201,                 /* opt_deep  */
  YYSYMBOL_func_params = 202,              /* func_params  */
  YYSYMBOL_opt_type = 203,                 /* opt_type  */
  YYSYMBOL_init_class = 204,               /* init_class  */
  YYSYMBOL_opt_init = 205,                 /* opt_init  */
  YYSYMBOL_206_32 = 206,                   /* $@32  */
  YYSYMBOL_207_33 = 207,                   /* $@33  */
  YYSYMBOL_index_slice = 208,              /* index_slice  */
  YYSYMBOL_opt_attr = 209,                 /* opt_attr  */
  YYSYMBOL_attr_list = 210,                /* attr_list  */
  YYSYMBOL_attr = 211,                     /* attr  */
  YYSYMBOL_stmt = 212,                     /* stmt  */
  YYSYMBOL_213_34 = 213,                   /* $@34  */
  YYSYMBOL_stmt_list = 214,                /* stmt_list  */
  YYSYMBOL_event = 215,                    /* event  */
  YYSYMBOL_case_list = 216,                /* case_list  */
  YYSYMBOL_case = 217,                     /* case  */
  YYSYMBOL_case_type_list = 218,           /* case_type_list  */
  YYSYMBOL_case_type = 219,                /* case_type  */
  YYSYMBOL_for_head = 220,                 /* for_head  */
  YYSYMBOL_local_id_list = 221,            /* local_id_list  */
  YYSYMBOL_local_id = 222,                 /* local_id  */
  YYSYMBOL_global_id = 223,                /* global_id  */
  YYSYMBOL_224_35 = 224,                   /* $@35  */
  YYSYMBOL_def_global_id = 225,            /* def_global_id  */
  YYSYMBOL_226_36 = 226,                   /* $@36  */
  YYSYMBOL_227_37 = 227,                   /* $@37  */
  YYSYMBOL_event_id = 228,                 /* event_id  */
  YYSYMBOL_229_38 = 229,                   /* $@38  */
  YYSYMBOL_global_or_event_id = 230,       /* global_or_event_id  */
  YYSYMBOL_resolve_id = 231,               /* resolve_id  */
  YYSYMBOL_lookup_identifier = 232,        /* lookup_identifier  */
  YYSYMBOL_opt_assert_msg = 233,           /* opt_assert_msg  */
  YYSYMBOL_opt_no_test = 234,              /* opt_no_test  */
  YYSYMBOL_opt_no_test_block = 235,        /* opt_no_test_block  */
  YYSYMBOL_opt_deprecated = 236,           /* opt_deprecated  */
  YYSYMBOL_expr_list_opt_comma = 237       /* expr_list_opt_comma  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3523

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  133
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  105
/* YYNRULES -- Number of rules.  */
#define YYNRULES  299
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  790

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   363


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by zeeklex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by zeeklex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   121,     2,     2,   123,   118,   111,     2,
     126,   127,   116,   114,    95,   115,     2,   117,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    98,   132,
     101,    96,   102,    97,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   124,     2,   125,   110,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   130,   109,   131,   122,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      99,   100,   103,   104,   105,   106,   107,   108,   112,   113,
     119,   120,   128,   129
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   398,   398,   397,   427,   427,   434,   435,   439,   442,
     446,   454,   458,   466,   472,   480,   483,   488,   490,   494,
     494,   494,   499,   505,   511,   517,   523,   529,   535,   541,
     547,   583,   589,   595,   619,   625,   646,   652,   661,   667,
     673,   679,   685,   691,   697,   703,   709,   715,   721,   727,
     733,   739,   745,   752,   751,   772,   781,   790,   792,   798,
     805,   804,   814,   820,   828,   854,   860,   860,   860,   868,
     875,   882,   888,   881,   931,   931,   944,   950,   952,   958,
    1023,  1029,  1036,  1036,  1053,  1060,  1066,  1073,  1073,  1078,
    1081,  1083,  1087,  1093,  1102,  1104,  1108,  1114,  1122,  1124,
    1133,  1146,  1154,  1164,  1170,  1176,  1182,  1188,  1194,  1200,
    1206,  1212,  1218,  1224,  1230,  1236,  1242,  1249,  1251,  1248,
    1258,  1258,  1265,  1273,  1281,  1287,  1293,  1299,  1306,  1307,
    1313,  1319,  1325,  1345,  1347,  1355,  1360,  1366,  1379,  1381,
    1384,  1388,  1390,  1392,  1397,  1406,  1413,  1413,  1416,  1421,
    1429,  1434,  1434,  1453,  1452,  1461,  1460,  1468,  1467,  1475,
    1477,  1479,  1474,  1492,  1491,  1503,  1502,  1509,  1512,  1513,
    1517,  1519,  1521,  1523,  1525,  1530,  1539,  1546,  1555,  1566,
    1575,  1565,  1595,  1601,  1594,  1628,  1627,  1648,  1667,  1670,
    1674,  1679,  1688,  1712,  1715,  1719,  1721,  1726,  1729,  1733,
    1734,  1735,  1736,  1740,  1740,  1740,  1743,  1747,  1771,  1773,
    1777,  1779,  1787,  1789,  1791,  1793,  1795,  1797,  1799,  1801,
    1803,  1805,  1807,  1809,  1811,  1813,  1815,  1817,  1819,  1821,
    1823,  1825,  1827,  1829,  1831,  1833,  1849,  1855,  1854,  1871,
    1876,  1884,  1892,  1900,  1909,  1916,  1923,  1930,  1938,  1946,
    1954,  1962,  1970,  1978,  1985,  1992,  2002,  2010,  2017,  2022,
    2029,  2033,  2059,  2062,  2066,  2069,  2072,  2077,  2080,  2088,
    2094,  2111,  2135,  2140,  2167,  2185,  2187,  2195,  2221,  2221,
    2226,  2226,  2226,  2231,  2231,  2236,  2275,  2289,  2291,  2303,
    2306,  2310,  2313,  2317,  2320,  2324,  2327,  2341,  2344,  2345
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOK_ADD",
  "TOK_ADD_TO", "TOK_ADDR", "TOK_ANY", "TOK_ASSERT", "TOK_ATENDIF",
  "TOK_ATELSE", "TOK_ATIF", "TOK_ATIFDEF", "TOK_ATIFNDEF", "TOK_BOOL",
  "TOK_BREAK", "TOK_CASE", "TOK_OPTION", "TOK_CONST", "TOK_CONSTANT",
  "TOK_COPY", "TOK_COUNT", "TOK_DEFAULT", "TOK_DELETE", "TOK_DOUBLE",
  "TOK_ELSE", "TOK_ENUM", "TOK_EVENT", "TOK_EXPORT", "TOK_FALLTHROUGH",
  "TOK_FILE", "TOK_FOR", "TOK_FUNCTION", "TOK_GLOBAL", "TOK_HOOK",
  "TOK_ID", "TOK_IF", "TOK_INT", "TOK_INTERVAL", "TOK_LIST", "TOK_MODULE",
  "TOK_LOCAL", "TOK_WHEN_LOCAL", "TOK_NEXT", "TOK_OF", "TOK_OPAQUE",
  "TOK_PATTERN", "TOK_PATTERN_END", "TOK_PATTERN_TEXT", "TOK_PORT",
  "TOK_PRINT", "TOK_RECORD", "TOK_REDEF", "TOK_REMOVE_FROM", "TOK_RETURN",
  "TOK_SCHEDULE", "TOK_SET", "TOK_STRING", "TOK_SUBNET", "TOK_SWITCH",
  "TOK_TABLE", "TOK_TIME", "TOK_TIMEOUT", "TOK_TYPE", "TOK_VECTOR",
  "TOK_WHEN", "TOK_WHILE", "TOK_AS", "TOK_IS", "TOK_GLOBAL_ID",
  "TOK_ATTR_ADD_FUNC", "TOK_ATTR_DEFAULT", "TOK_ATTR_DEFAULT_INSERT",
  "TOK_ATTR_OPTIONAL", "TOK_ATTR_REDEF", "TOK_ATTR_DEL_FUNC",
  "TOK_ATTR_EXPIRE_FUNC", "TOK_ATTR_EXPIRE_CREATE", "TOK_ATTR_EXPIRE_READ",
  "TOK_ATTR_EXPIRE_WRITE", "TOK_ATTR_RAW_OUTPUT", "TOK_ATTR_ON_CHANGE",
  "TOK_ATTR_BROKER_STORE", "TOK_ATTR_BROKER_STORE_ALLOW_COMPLEX",
  "TOK_ATTR_BACKEND", "TOK_ATTR_PRIORITY", "TOK_ATTR_LOG",
  "TOK_ATTR_ERROR_HANDLER", "TOK_ATTR_GROUP", "TOK_ATTR_TYPE_COLUMN",
  "TOK_ATTR_DEPRECATED", "TOK_ATTR_IS_ASSIGNED", "TOK_ATTR_IS_USED",
  "TOK_ATTR_ORDERED", "TOK_DEBUG", "TOK_NO_TEST", "','", "'='", "'?'",
  "':'", "TOK_OR_OR", "TOK_AND_AND", "'<'", "'>'", "TOK_LE", "TOK_GE",
  "TOK_EQ", "TOK_NE", "TOK_IN", "TOK_NOT_IN", "'|'", "'^'", "'&'",
  "TOK_LSHIFT", "TOK_RSHIFT", "'+'", "'-'", "'*'", "'/'", "'%'",
  "TOK_INCR", "TOK_DECR", "'!'", "'~'", "'$'", "'['", "']'", "'('", "')'",
  "TOK_HAS_FIELD", "TOK_HAS_ATTR", "'{'", "'}'", "';'", "$accept", "zeek",
  "$@1", "$@2", "decl_list", "opt_expr", "when_clause", "when_head",
  "when_start", "when_flavor", "when_captures", "when_condition", "$@3",
  "$@4", "expr", "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12",
  "rhs", "$@13", "rhs_expr_list", "expr_list", "opt_expr_list",
  "enum_body", "enum_body_list", "enum_body_elem", "simple_type", "$@14",
  "$@15", "$@16", "type", "type_list", "type_decl_list", "type_decl",
  "formal_args", "formal_args_decl_list", "formal_args_decl", "decl",
  "$@17", "$@18", "$@19", "$@20", "$@21", "$@22", "$@23", "$@24", "$@25",
  "$@26", "conditional_list", "conditional", "func_hdr", "func_body",
  "$@27", "$@28", "lambda_body", "$@29", "$@30", "anonymous_function",
  "$@31", "begin_lambda", "opt_captures", "capture_list", "capture",
  "opt_deep", "func_params", "opt_type", "init_class", "opt_init", "$@32",
  "$@33", "index_slice", "opt_attr", "attr_list", "attr", "stmt", "$@34",
  "stmt_list", "event", "case_list", "case", "case_type_list", "case_type",
  "for_head", "local_id_list", "local_id", "global_id", "$@35",
  "def_global_id", "$@36", "$@37", "event_id", "$@38",
  "global_or_event_id", "resolve_id", "lookup_identifier",
  "opt_assert_msg", "opt_no_test", "opt_no_test_block", "opt_deprecated",
  "expr_list_opt_comma", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-569)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-207)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -73,  -569,    38,  3461,  2906,  -569,  -569,  -569,   -44,   -34,
      34,  -569,  -569,  -569,    41,  -569,  -569,  -569,   133,   151,
    -569,  -569,  -569,  -569,  -569,  2906,  -569,  -569,  -569,  -569,
      42,  -569,  2906,  -569,    59,   138,  -569,  -569,  -569,  -569,
    -569,   143,   156,   155,  -569,  -569,   -90,  2906,    48,  -569,
    -569,    61,  -569,    -1,  -569,  2906,  2906,  2906,  -569,  2906,
    2906,  2906,  2906,   160,  2906,  2906,  2534,  -569,  -569,  -569,
    -569,  2906,   171,   172,   121,  -569,   121,    94,    25,  -569,
      94,   121,    94,    92,  -569,  -569,  -569,  -569,    25,   137,
    1079,  -569,  2534,  2906,  2534,  -569,  3218,   113,  2906,  3218,
    -569,   145,   208,  2906,  -569,  1460,  3218,  2906,  3218,  -569,
    3218,  2906,  2601,   286,   286,   198,   286,   286,   286,   286,
      56,  2534,   152,   123,  1663,  1362,  1362,  3218,  3218,  -569,
    3028,  2906,  2906,  2906,  2906,  2906,  2906,  2906,  2906,  2906,
    2906,  2906,  2906,  2906,  2906,  2906,  2906,  2906,  2906,  2906,
    2906,   219,  3028,  -569,   220,  1730,   128,   129,  3218,    10,
    -569,    10,   223,  1934,  -569,  -569,  -569,  1934,    10,  1934,
    -569,   257,    94,   139,   121,  -569,  -569,  2906,   131,   156,
      25,   132,   140,   141,   156,   136,  2906,  1201,  2906,  -569,
     146,  -569,  -569,  -569,   212,  1079,    71,   799,  -569,   178,
    -569,  1079,    36,  1797,   241,   150,    94,   153,   148,   157,
     159,   242,  -569,  -569,  -569,  -569,   270,  -569,    94,  3247,
    -569,  1362,  -569,   -19,  -569,    25,  -569,   -20,   163,   -16,
    2906,  -569,   165,  3150,   247,  2906,   207,  2906,  -569,  -569,
    -569,  -569,  2534,  -569,  -569,  -569,  -569,  1362,  1864,  2757,
    3247,  3277,  3277,  3277,  3277,  3277,  3277,   245,   245,   429,
    1557,  1690,   495,   495,   317,   317,   286,   286,   286,  -569,
     206,  1931,   -12,  2906,  -569,  -569,  -569,  -569,  -569,  -569,
    -569,  -569,   951,  -569,   951,   209,   181,   -46,  -569,   213,
     214,   217,  -569,  -569,   218,   222,   227,   228,   229,  -569,
     231,   236,  -569,   240,   246,  -569,  -569,   249,   253,   254,
    -569,  -569,  -569,  -569,  1934,  -569,   289,  -569,   951,  -569,
     189,  1934,   307,   339,    10,  3218,  1998,   271,   121,   235,
     248,   271,    -8,  2906,   121,   271,   -45,  -569,   271,  1177,
    1529,  2906,   278,  2906,  -569,    76,  -569,   271,  2906,  -569,
    -569,  -569,  -569,  -569,    22,   244,   284,  -569,   223,  -569,
     223,  -569,   -10,  -569,   353,    62,  -569,  -569,  2906,  -569,
     255,   258,  3218,  -569,  1934,   345,   263,  -569,  -569,  2534,
    -569,  2534,  2906,  -569,  2906,  2906,  -569,  -569,  1934,  1362,
    1934,  3218,   309,   223,   223,  2906,  2906,  2906,  2906,  2906,
    2906,  2906,  2906,  2906,  2906,  2906,  2906,  2906,  2906,   390,
    -569,  -569,  1934,  -569,  -569,   359,   283,   951,  1934,  2906,
     285,  -569,  -569,    10,   271,  2906,  -569,   -78,   156,  2065,
      10,  -569,   271,  -569,   271,  -569,  2132,  -569,  -569,  1596,
     291,   327,   298,  2906,  -569,  1246,  -569,   330,     4,  -569,
    -569,   241,   300,   301,   270,  -569,  -569,  -569,  -569,   299,
     204,  -569,  -569,  -569,  3218,  -569,   302,   305,   152,  1059,
     304,  2534,   311,   312,  -569,   314,  1934,  3218,  -569,  -569,
    2534,  2534,  2534,  2534,  2534,  2534,  2534,  2534,  2534,  2534,
    2534,  2534,  2534,  2534,  -569,   319,   241,   448,   401,  -569,
    1934,   322,  2534,  -569,   951,  -569,   328,   422,  2906,    -5,
    -569,  1079,   951,  -569,  -569,    20,  1079,   819,   278,   331,
    -569,  2534,   271,  1079,   440,   370,   442,  -569,  -569,  -569,
    -569,  -569,  -569,   364,  -569,  -569,  1934,  -569,  -569,  -569,
    -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,   332,   335,
     336,  -569,   337,  -569,  1934,  -569,   360,  2199,   156,   -11,
     444,  1934,  2784,   374,  -569,  -569,  -569,  -569,  -569,  -569,
    -569,  -569,   346,  -569,  -569,  -569,  1079,  3218,  -569,   347,
    1934,  1934,   350,  -569,   351,  2906,  -569,  -569,   452,  2906,
    1079,   355,  3274,   -17,     3,  -569,  -569,   949,   361,  -569,
     358,  1934,  -569,  2667,  2907,   371,   271,  2266,   375,  2333,
    -569,   271,   426,  -569,   439,  -569,  1079,  -569,  -569,  -569,
     377,   379,   380,  1934,  -569,  -569,  2906,  -569,  -569,   473,
    1079,  -569,  1079,  -569,  -569,  -569,   394,  2400,  -569,  -569,
    -569,  3028,  3028,   471,  -569,   484,   156,    99,   110,    37,
    3028,  3028,  3028,  3028,  3028,  3028,   498,  1484,  1484,  3274,
    3274,  -569,  3028,  3028,  3028,  3028,  3028,  3028,  3028,  3028,
    3028,  3028,  3028,  3028,  3028,  3028,  3028,  3028,  3028,  3028,
    3028,  3028,  3028,  2668,   403,   412,   494,  3028,  2668,  2668,
    3274,  3028,  3274,   453,  2906,  3218,  -569,  3274,   352,   352,
     352,   352,   352,   352,    69,  2668,  1484,  2467,  3001,  3310,
    3340,  3340,  3340,  3340,  3340,  3340,   407,   407,   673,  1624,
    1757,  1822,  1822,   382,   382,   352,   352,   352,   223,  2668,
    3310,  1484,   411,    29,  2906,  3028,  3028,   421,  2068,   508,
     427,  2668,  1335,  -569,   460,   463,   464,   467,   469,   470,
     472,   474,   476,   477,   478,   479,   481,   482,  2068,  3274,
    -569,  3028,  3028,  3028,  3028,  3028,  3028,  3028,  3028,  3028,
    3028,  3028,  3028,  3028,  3028,  2068,  2668,  2668,  2668,  2668,
    2668,  2668,  2668,  2668,  2668,  2668,  2668,  2668,  2668,  2668
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       7,     4,     0,     2,     0,     1,   173,   174,     0,     0,
       0,   280,   280,   283,     0,   280,   280,   280,     0,   278,
     280,   260,     6,   167,   165,     0,   112,   114,   103,    80,
       0,   105,     0,   106,     0,   126,   185,    74,   287,   104,
     108,   122,     0,     0,   110,   111,     0,     0,     0,   109,
     113,     0,   107,     0,   288,     0,     0,     0,    82,     0,
       0,     0,     0,     0,    95,     0,     5,    81,    77,    57,
      79,     0,     0,     0,   198,   278,   198,     0,     0,   146,
       0,   198,     0,     0,   278,   283,   278,   151,     0,     0,
       3,   168,    24,     0,    25,   120,     0,   189,     0,     0,
     277,     0,     0,     0,   117,     0,     0,    95,     0,    66,
       0,    95,     0,    31,    30,     0,    26,    27,    28,    29,
     189,    93,   299,     0,     0,     0,     0,     0,     0,    53,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     9,    71,     0,     0,     0,     0,     0,   199,
     281,   199,   140,   209,   284,   285,     7,   209,   199,   209,
     145,     0,     0,   159,   198,   279,   163,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
       0,   237,   257,   254,    11,     0,     0,     0,   258,    57,
     259,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   128,   125,   132,   286,   194,   168,     0,    75,
     123,     0,   127,     0,   136,     0,   134,     0,     0,     0,
      95,   124,     0,    84,     0,     0,     0,   298,    94,    64,
      22,    87,    89,    33,    35,    85,    86,     0,     0,    45,
      44,    48,    50,    49,    51,    46,    47,    62,    63,    40,
      41,    39,    42,    43,    32,    34,    36,    37,    38,    58,
       0,    93,     0,    95,    76,   170,   171,   172,   197,   201,
     202,   200,   203,   282,   203,     0,     0,   138,   143,     0,
       0,     0,   214,   215,     0,     0,     0,     0,     0,   228,
       0,     0,   222,     0,     0,   232,   233,     0,     0,   234,
     216,   217,   236,   176,   208,   211,     0,   175,   203,   177,
       0,   209,     0,     0,   199,     0,   290,   292,   198,     0,
       0,   292,     0,     0,   198,   292,     0,    15,   292,     0,
       0,     0,   294,     0,    12,    18,    19,   292,     0,   245,
     179,   169,   166,    23,   297,     0,    96,    98,   140,   129,
     140,   193,     0,   191,     0,     0,   187,    55,     0,    65,
     168,     0,     0,   116,   209,     0,     0,    70,    83,    59,
      60,    92,    91,    54,     0,     9,    56,    72,   209,     0,
     209,     0,   196,     0,   139,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     210,   147,   209,   153,   178,   155,     0,   203,   209,     0,
       0,   291,   248,   199,   292,    95,   249,     0,     0,     0,
     199,   247,   292,   250,   292,   263,     0,   293,   260,     0,
       0,    17,     0,     0,   256,     0,   260,   295,     0,   102,
     121,    97,     0,     0,   194,   188,   192,   182,   186,     0,
       0,    78,   133,    69,     0,    67,     0,     0,   299,    52,
       0,     8,     0,     0,   204,     0,   209,     0,   142,   141,
     218,   212,   213,   219,   224,   225,   226,   227,   220,   221,
     223,   229,   230,   231,   235,     0,     0,     0,     0,   160,
     209,     0,   289,   239,   203,   241,     0,     0,     0,     0,
     276,     0,   203,   240,   251,     0,     0,     0,   294,     0,
      14,    20,   292,   180,     0,   297,     0,    99,   131,   130,
     190,   260,   119,     0,   135,   115,   209,    61,    88,    90,
     207,    73,   149,   205,   150,   144,   195,   148,     0,     0,
       0,   136,     0,   164,   209,   261,     0,     0,     0,     0,
     242,   209,     0,     0,   244,   262,   246,   238,   260,    19,
      21,   255,     0,   296,   100,   101,   183,     0,    68,     0,
       0,     0,   168,   152,     0,     0,   271,   275,     0,     0,
       0,     0,     0,     0,     0,   268,   260,     0,     0,   181,
       0,   209,   154,     0,     0,     0,   292,     0,     0,     0,
     243,   292,   269,   260,     0,   260,   266,    10,    13,   184,
       0,     0,     0,   209,   253,   273,     0,   272,   252,     0,
     264,   267,   265,   137,   156,   158,     0,     0,   270,   162,
     274,     0,     0,   126,    74,   122,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    53,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    93,     0,     0,     0,     0,    24,    25,
       0,     0,     0,     0,    95,     0,    66,     0,    31,    30,
      26,    27,    28,    29,   189,    89,     0,     0,    45,    44,
      48,    50,    49,    51,    46,    47,    62,    63,    40,    41,
      39,    42,    43,    32,    34,    36,    37,    38,   140,    92,
      75,     0,     0,     0,    95,     0,     0,     0,   209,     0,
       0,    59,    52,   196,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   208,     0,
      67,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   209,   218,   212,   213,   219,
     224,   225,   226,   227,   220,   221,   223,   229,   230,   231
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -569,  -569,  -569,  -569,   413,   182,  -569,  -569,  -569,  -569,
    -569,     0,  -569,  -569,    -4,   -81,  -569,  -113,  -173,  -569,
    -569,   -60,  -569,  -124,  -569,  -569,   -98,   -77,    95,  -569,
     142,    51,  -569,  -569,  -569,   112,  -107,    43,  -569,  -351,
    -569,  -238,  -569,  -569,  -569,  -569,  -569,  -569,  -569,  -569,
    -569,  -569,  -569,   -68,     1,  -569,  -569,  -569,  -569,   126,
    -569,  -569,  -569,  -569,   499,  -569,   250,   144,  -569,   -14,
     -57,  -136,  -253,  -569,  -569,   -26,  -130,  -568,  -308,  -185,
    -569,  -369,   372,  -569,  -569,  -569,   -13,  -569,  -569,  -176,
      16,  -569,   318,  -569,  -569,   515,  -569,   514,  -569,   122,
    -569,  -320,    85,    80,   147
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,    21,     4,     3,   270,   193,   194,   195,   196,
     440,   442,   443,   570,   197,   247,   466,   230,   536,   273,
     472,    98,   115,   243,   382,   467,   122,   123,   355,   356,
     357,    67,   224,   459,   204,   226,   227,   370,   534,   286,
     287,   288,    22,   166,   174,   496,   497,   498,   323,   551,
     605,   325,    91,   460,   198,    24,   352,   446,   572,   458,
     531,   600,    68,    97,   236,   218,   362,   363,   364,   359,
     159,   282,   388,   389,   543,    69,   463,   314,   315,   200,
     342,    90,   329,   515,   565,   594,   595,   201,   509,   101,
      87,    88,    74,    75,   283,    77,    78,   164,   214,    70,
     420,   422,   438,   449,   238
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      66,   229,   244,   328,    23,   223,   410,   452,   334,   453,
     344,   426,   603,   604,   279,   431,   349,   507,   433,   161,
       1,    92,   525,   202,   168,   284,   427,   444,    94,   508,
     228,   390,   318,   313,   232,   562,   103,   317,     5,   319,
     104,   563,   110,   105,     6,     7,     8,     9,    10,   393,
     368,   112,   113,   114,   272,   116,   117,   118,   119,    38,
     121,   124,   280,   163,   199,   412,   167,   155,   169,   517,
       6,     7,     8,     9,    10,   372,   368,   523,   687,   372,
     697,   613,    71,   368,   588,   454,   394,   432,   336,   203,
     558,   160,    72,    54,   219,   361,   589,   367,   614,   121,
     171,   615,   173,   121,   505,   373,   281,   121,   369,   375,
    -194,   447,   513,   386,   514,   455,   428,   324,   448,   526,
     559,   242,   242,   383,   372,   111,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   212,   271,   365,
     212,   564,   235,   376,   739,   478,   479,   212,   321,   212,
      73,   212,   576,   111,   500,   735,   350,    83,    93,   199,
     758,    79,   106,   326,   107,   199,    84,    85,   212,   212,
     216,    96,   121,   339,   340,   108,    99,   109,   417,    95,
     100,   414,   457,   216,   120,   345,   387,   346,   102,   597,
     165,    86,   571,   351,   366,   156,   157,   758,   213,   212,
     165,   220,     6,     7,     8,     9,    10,   242,   215,   158,
     162,   215,   231,   106,   170,   694,   121,   616,   215,   259,
     215,   379,   215,   381,   695,   176,   696,   216,   533,   245,
     246,   221,   222,   242,   630,   234,   632,   237,   239,   215,
     215,   554,   510,   269,   274,   276,   277,   285,   473,   561,
     475,   320,   322,   327,   331,   474,   332,   333,   335,   121,
     278,   423,   341,   343,   348,   354,   358,   430,   104,   360,
     215,   106,   495,   108,   468,   110,   624,   504,   501,   361,
     374,   628,   377,   378,   512,   410,   410,     6,     7,     8,
       9,    10,   330,   380,   385,    11,    12,   391,   392,   395,
     396,   127,   128,   397,   398,    13,    14,    23,   399,   413,
      15,    16,    17,   400,   401,   402,   560,   403,    18,   429,
      76,   566,   404,    80,    81,    82,   405,   436,    89,   439,
      19,   415,   406,   416,   445,   407,   545,   330,   506,   408,
     409,    20,   127,   128,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   381,   421,   351,   424,   151,   152,
     552,   153,   437,   154,   425,   450,   212,   737,   121,   451,
     469,   471,   587,   127,   128,   242,  -118,   456,   464,   461,
     465,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   610,   578,   477,   494,   151,
     152,  -157,   153,   499,   154,   502,   519,   503,   659,   660,
     411,   121,   454,   212,   584,   520,   524,   528,   529,   540,
     532,   591,   457,   148,   149,   150,   538,   418,   541,   521,
     151,   152,   212,   153,   542,   154,   544,   215,   659,   660,
     410,   547,   549,   550,   553,   555,   556,   569,   573,   447,
     575,   351,   577,   579,   593,   580,   581,   585,   590,   583,
     693,   620,   596,   659,   660,   151,   152,   599,   153,   602,
     154,  -161,   626,   606,   462,   199,   608,   611,   618,   619,
     199,   199,   629,   636,   215,   127,   128,   199,   680,   681,
     682,   592,   623,   476,   557,   151,   152,   638,   153,   633,
     154,   634,   635,   215,   690,   212,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   639,   692,   212,   728,
     151,   152,   704,   153,   244,   154,   695,   697,   738,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   743,   731,
     199,   759,   151,   152,   760,   153,   761,   154,   683,   762,
     763,   127,   128,   764,   199,   765,   766,   470,   767,   598,
     768,   199,   769,   770,   771,   772,   535,   773,   774,   316,
     706,   607,   383,   734,   691,   609,   215,   775,   733,   546,
     199,   548,   537,   527,   582,   441,   217,   371,   530,   215,
     172,   631,   175,   568,   199,   574,   199,   367,     0,   146,
     147,   148,   149,   150,     0,   539,     0,   732,   151,   152,
       0,   153,   637,   154,     0,     0,     0,     0,   212,     0,
       0,     0,     0,     0,     0,     0,     0,   688,   689,     0,
       0,     0,     0,   212,     0,   578,   698,   699,   700,   701,
     702,   703,     0,   705,   705,     0,     0,   740,   707,   708,
     709,   710,   711,   712,   713,   714,   715,   716,   717,   718,
     719,   720,   721,   722,   723,   724,   725,   726,   727,     0,
       0,     0,     0,   729,     0,     0,     0,   730,     0,   601,
     121,     0,     0,     0,     0,     0,     0,     0,     0,   215,
       0,     0,   705,     0,   612,     0,     0,     0,     0,     0,
     212,   212,     0,     0,   215,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   705,     0,     0,
     121,   741,   742,     0,     0,     0,     0,     0,     0,   659,
     660,   212,     0,   212,     0,     0,   212,     0,   212,     0,
       0,     0,     0,     0,     0,     0,     0,   776,   777,   778,
     779,   780,   781,   782,   783,   784,   785,   786,   787,   788,
     789,   245,   246,     0,     0,     0,     0,     0,     0,     0,
       0,   215,   215,   674,   675,   676,   677,   678,   679,   680,
     681,   682,     0,     0,     0,     0,   151,   152,     0,   153,
       0,   154,   213,   125,   220,     0,     0,     0,     0,   231,
     212,     0,   215,     0,   215,     0,     0,   215,     0,   215,
       0,     0,    25,     0,    26,    27,   177,     6,     7,     8,
       9,    10,    28,   178,     0,     0,   179,    29,    30,    31,
       0,    32,    33,     0,    34,   180,     0,   181,    35,   182,
      36,   126,    37,    38,   183,    39,    40,    41,     0,   184,
      42,   185,     0,    43,    44,   127,   128,    45,   186,    46,
       0,   535,   187,    47,    48,    49,    50,   188,    51,    52,
       0,   215,    53,   189,   190,     0,     0,    54,     0,     0,
       0,     0,     0,     0,     0,   129,   130,     0,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,     0,     0,
       0,     0,   151,   152,     0,   153,     0,   154,    55,     0,
       0,   347,     0,    56,    57,     0,    58,     0,    59,    60,
      61,    62,    63,    64,     0,    65,     0,     0,     0,   191,
     567,   192,    25,     0,    26,    27,   177,     6,     7,     8,
       9,    10,    28,   178,     0,     0,   179,    29,    30,    31,
       0,    32,    33,     0,    34,   180,     0,   181,    35,   182,
      36,     0,    37,    38,   183,    39,    40,    41,     0,   184,
      42,   185,     0,    43,    44,     0,     0,    45,   186,    46,
       0,     0,   187,    47,    48,    49,    50,   188,    51,    52,
       0,     0,    53,   189,   190,     0,     0,    54,     0,     0,
    -206,  -206,  -206,  -206,  -206,  -206,  -206,  -206,  -206,  -206,
    -206,  -206,  -206,  -206,  -206,  -206,  -206,  -206,  -206,  -206,
    -206,  -206,  -206,  -206,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    55,     0,
       0,     0,     0,    56,    57,     0,    58,     0,    59,    60,
      61,    62,    63,    64,     0,    65,     0,     0,     0,   191,
     617,   192,    25,  -206,    26,    27,   177,     6,     7,     8,
       9,    10,    28,   178,     0,     0,   179,    29,    30,    31,
       0,    32,    33,     0,    34,   180,     0,   181,    35,   182,
      36,     0,    37,    38,   183,    39,    40,    41,     0,   184,
      42,   185,     0,    43,    44,   127,   128,    45,   186,    46,
       0,     0,   187,    47,    48,    49,    50,   188,    51,    52,
       0,     0,    53,   189,   190,     0,     0,    54,     0,     0,
       0,     0,     0,     0,     0,     0,   130,     0,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,     0,     0,
       0,   125,   151,   152,     0,   153,     0,   154,    55,     0,
       0,     0,     0,    56,    57,     0,    58,     0,    59,    60,
      61,    62,    63,    64,    25,    65,    26,    27,     0,   191,
       0,   192,     0,     0,    28,     0,     0,     0,     0,    29,
      30,    31,     0,    32,    33,     0,    34,     0,     0,   126,
      35,     0,    36,     0,    37,    38,     0,    39,    40,    41,
       0,     0,    42,   127,   128,    43,    44,     0,     0,    45,
     125,    46,     0,     0,     0,    47,    48,    49,    50,     0,
      51,    52,     0,     0,    53,   337,     0,     0,     0,    54,
       0,     0,     0,   129,   130,     0,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,     0,     0,   126,     0,
     151,   152,     0,   153,     0,   154,     0,     0,     0,   434,
      55,     0,   127,   128,     0,    56,    57,     0,    58,     0,
      59,    60,    61,    62,    63,    64,     0,    65,     0,     0,
       0,     0,     0,   338,     0,     0,     0,     0,     0,     0,
       0,     0,   129,   130,     0,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,    25,     0,    26,    27,   151,
     152,     0,   153,     0,   154,    28,     0,     0,   522,     0,
      29,    30,    31,     0,    32,    33,     0,    34,     0,     0,
       0,    35,     0,    36,     0,    37,    38,     0,    39,    40,
      41,   659,   660,    42,     0,     0,    43,    44,     0,     0,
      45,     0,    46,     0,     0,     0,    47,    48,    49,    50,
       0,    51,    52,     0,     0,    53,     0,     0,     0,     0,
      54,     0,   662,     0,   663,   664,   665,   666,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   676,   677,   678,
     679,   680,   681,   682,     0,     0,     0,     0,   151,   152,
       0,   153,     0,   154,   125,     0,     0,     0,     0,     0,
       0,    55,     0,     0,     0,     0,    56,    57,     0,    58,
       0,    59,    60,    61,    62,    63,    64,   641,    65,    26,
      27,     0,   241,     0,     0,     0,     0,    28,     0,     0,
       0,     0,    29,    30,    31,     0,   642,    33,     0,    34,
       0,     0,   126,   643,     0,    36,     0,   644,    38,     0,
      39,    40,   645,     0,     0,   646,   127,   128,    43,    44,
       0,     0,    45,   125,    46,     0,     0,     0,    47,   647,
      49,    50,     0,   648,    52,     0,     0,   649,     0,     0,
       0,     0,    54,     0,     0,     0,   129,   130,     0,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,     0,
       0,   126,     0,   151,   152,     0,   153,     0,   154,     0,
     225,     0,     0,    55,     0,   127,   128,     0,   650,   651,
     125,    58,     0,   652,   653,   654,   655,   656,    64,     0,
      65,     0,     0,     0,   241,     0,     0,     0,     0,     0,
       0,     0,     0,   127,   128,   129,   130,     0,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   126,     0,
       0,     0,   151,   152,     0,   153,     0,   154,     0,   435,
       0,     0,   127,   128,     0,     0,     0,   125,   143,   144,
     145,   146,   147,   148,   149,   150,     0,     0,     0,     0,
     151,   152,     0,   153,     0,   154,     0,     0,     0,     0,
     659,   660,   129,   130,     0,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   126,     0,     0,     0,   151,
     152,     0,   153,     0,   154,     0,   518,     0,     0,   127,
     128,     0,     0,     0,   125,   675,   676,   677,   678,   679,
     680,   681,   682,     0,     0,     0,     0,   151,   152,     0,
     153,     0,   154,     0,     0,     0,   127,   128,     0,   129,
     130,     0,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   126,     0,     0,     0,   151,   152,     0,   153,
     240,   154,     0,     0,     0,     0,   127,   128,     0,     0,
       0,   125,   144,   145,   146,   147,   148,   149,   150,     0,
       0,     0,     0,   151,   152,     0,   153,     0,   154,     0,
       0,     0,     0,   659,   660,     0,   129,   130,     0,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   126,
       0,     0,     0,   151,   152,     0,   153,   275,   154,     0,
       0,     0,     0,   127,   128,     0,     0,     0,   657,   676,
     677,   678,   679,   680,   681,   682,     0,     0,     0,     0,
     151,   152,     0,   153,     0,   154,     0,     0,   659,   660,
       0,     0,     0,   129,   130,     0,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   658,     0,     0,     0,
     151,   152,     0,   153,   353,   154,     0,     0,     0,     0,
     659,   660,     0,     0,     0,   657,   678,   679,   680,   681,
     682,     0,     0,     0,     0,   151,   152,     0,   153,     0,
     154,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     661,   662,   384,   663,   664,   665,   666,   667,   668,   669,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   679,
     680,   681,   682,   658,     0,     0,     0,   151,   152,     0,
     153,     0,   154,     0,     0,     0,     0,   659,   660,     0,
       0,     0,   125,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   661,   662,    -8,
     663,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
     126,     0,     0,     0,   151,   152,     0,   153,     0,   154,
       0,     0,     0,     0,   127,   128,     0,     0,     0,   125,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   419,   129,   130,     0,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   126,     0,     0,
       0,   151,   152,     0,   153,     0,   154,     0,     0,     0,
       0,   127,   128,     0,     0,     0,   125,   744,   745,   746,
     292,   293,   747,   748,   749,   750,   751,   299,   752,   753,
     302,   754,   755,   305,   306,   756,   757,   309,   310,   311,
     312,   129,   130,     0,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   126,     0,     0,     0,   151,   152,
       0,   153,   511,   154,     0,     0,     0,     0,   127,   128,
       0,     0,     0,   125,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   129,   130,
       0,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   126,     0,     0,     0,   151,   152,     0,   153,   516,
     154,     0,     0,     0,     0,   127,   128,     0,     0,     0,
     125,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   129,   130,     0,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   126,     0,
       0,     0,   151,   152,     0,   153,   586,   154,     0,     0,
       0,     0,   127,   128,     0,     0,     0,   125,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   129,   130,     0,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   126,     0,     0,     0,   151,
     152,     0,   153,   625,   154,     0,     0,     0,     0,   127,
     128,     0,     0,     0,   125,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   129,
     130,     0,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   126,     0,     0,     0,   151,   152,     0,   153,
     627,   154,     0,     0,     0,     0,   127,   128,     0,     0,
       0,   657,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   129,   130,     0,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   658,
       0,     0,     0,   151,   152,     0,   153,   640,   154,     0,
       0,     0,     0,   659,   660,     0,     0,     0,   125,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   661,   662,   736,   663,   664,   665,   666,
     667,   668,   669,   670,   671,   672,   673,   674,   675,   676,
     677,   678,   679,   680,   681,   682,   126,     0,     0,     0,
     151,   152,     0,   153,     0,   154,     0,     0,     0,     0,
     127,   128,     0,     0,     0,   125,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     129,   130,     0,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   126,     0,     0,     0,   151,   152,     0,
     153,     0,   154,     0,     0,     0,     0,   127,   128,     0,
       0,     0,   657,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   129,   130,     0,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     233,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     658,     0,     0,     0,   151,   152,     0,   153,     0,   154,
       0,     0,     0,     0,   659,   660,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,     0,     0,     0,   661,   662,     0,   663,   664,   665,
     666,   667,   668,   669,   670,   671,   672,   673,   674,   675,
     676,   677,   678,   679,   680,   681,   682,   641,     0,    26,
      27,   151,   152,     0,   153,     0,   154,    28,   621,     0,
       0,     0,    29,    30,    31,     0,   642,    33,     0,    34,
       0,     0,     0,   643,     0,    36,     0,   644,    38,     0,
      39,    40,   645,   127,   128,   646,     0,     0,    43,    44,
       0,     0,    45,     0,    46,     0,     0,     0,    47,   647,
      49,    50,     0,   648,    52,     0,   592,   649,     0,     0,
       0,     0,    54,     0,     0,     0,     0,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,     0,     0,     0,     0,
     151,   152,     0,   153,     0,   154,     0,     0,     0,     0,
       0,     0,     0,    55,     0,     0,     0,     0,   650,   651,
       0,    58,     0,   652,   653,   654,   655,   656,    64,    25,
      65,    26,    27,     0,     0,     0,     0,     0,     0,    28,
       0,     0,     0,     0,    29,    30,    31,     0,    32,    33,
       0,    34,     0,     0,     0,    35,     0,    36,     0,    37,
      38,     0,    39,    40,    41,     0,     0,    42,     0,     0,
      43,    44,     0,     0,    45,     0,    46,     0,     0,     0,
      47,    48,    49,    50,     0,    51,    52,     0,     0,    53,
       0,     0,     0,     0,    54,     0,   289,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    55,     0,     0,     0,     0,
      56,    57,     0,    58,     0,    59,    60,    61,    62,    63,
      64,   641,    65,    26,    27,     0,     0,     0,   622,     0,
       0,    28,     0,     0,     0,     0,    29,    30,    31,     0,
     642,    33,     0,    34,     0,     0,     0,   643,     0,    36,
       0,   644,    38,     0,    39,    40,   645,   659,   660,   646,
       0,     0,    43,    44,     0,     0,    45,     0,    46,     0,
       0,     0,    47,   647,    49,    50,     0,   648,    52,     0,
       0,   649,     0,     0,     0,     0,    54,     0,     0,     0,
       0,   664,   665,   666,   667,   668,   669,   670,   671,   672,
     673,   674,   675,   676,   677,   678,   679,   680,   681,   682,
       0,     0,     0,     0,   151,   152,     0,   153,     0,   154,
       0,     0,     0,     0,     0,     0,     0,    55,     0,     0,
       0,     0,   650,   651,     0,    58,     0,   652,   653,   654,
     655,   656,    64,    25,    65,    26,    27,     0,     0,     0,
       0,     0,     0,    28,     0,     0,     0,     0,    29,    30,
      31,     0,    32,    33,     0,    34,     0,     0,     0,    35,
       0,    36,     0,    37,    38,     0,    39,    40,    41,     0,
       0,    42,     0,     0,    43,    44,     0,     0,    45,     0,
      46,     0,     0,     0,    47,    48,    49,    50,     0,    51,
      52,     0,     0,    53,     0,     0,     0,     0,    54,     0,
       0,     0,     0,    26,    27,     0,     0,     0,     0,     0,
       0,    28,     0,     0,     0,     0,     0,     0,    31,     0,
       0,    33,     0,    34,   205,     0,     0,    35,     0,   206,
       0,   207,    38,     0,    39,    40,    41,     0,     0,     0,
       0,     0,    43,    44,     0,     0,    45,     0,   208,    59,
      60,    61,    62,   209,    49,    50,     0,   210,    52,    26,
      27,   211,     0,     0,     0,     0,    54,    28,     0,     0,
       0,     0,     0,     0,    31,     0,     0,    33,     0,    34,
     205,     0,     0,   643,     0,   684,     0,   207,    38,     0,
      39,    40,   645,   127,   128,     0,     0,     0,    43,    44,
       0,     0,    45,     0,   208,     0,     0,     0,     0,   209,
      49,    50,     0,   685,    52,     0,     0,   686,     0,     0,
       0,     0,    54,   127,   128,     0,     0,     0,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,     0,     0,     0,     0,
     151,   152,     0,   153,     0,   154,   659,   660,  -207,  -207,
    -207,  -207,  -207,  -207,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,     0,     0,     0,     0,
     151,   152,     0,   153,     0,   154,   659,   660,     0,     0,
       0,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,     0,
       0,     0,     0,   151,   152,     0,   153,     0,   154,     0,
       0,  -207,  -207,  -207,  -207,  -207,  -207,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,     0,
       0,     0,     0,   151,   152,     0,   153,     0,   154,     6,
       7,     8,     9,    10,     0,     0,     0,    11,    12,     0,
       0,     0,     0,     0,     0,     0,     0,    13,    14,     0,
       0,     0,    15,    16,    17,     0,     0,     0,     0,     0,
      18,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    19,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20
};

static const yytype_int16 yycheck[] =
{
       4,   108,   126,   179,     3,   103,   314,   358,   184,   360,
     195,   331,   580,   581,     4,   335,   201,    95,   338,    76,
      93,    25,    18,    91,    81,   161,    34,   347,    32,   107,
     107,   284,   168,   163,   111,    15,   126,   167,     0,   169,
     130,    21,    43,    47,     8,     9,    10,    11,    12,    95,
      95,    55,    56,    57,   152,    59,    60,    61,    62,    34,
      64,    65,    52,    77,    90,   318,    80,    71,    82,   438,
       8,     9,    10,    11,    12,    95,    95,   446,    95,    95,
      43,    98,   126,    95,    95,    95,   132,   132,   186,    93,
      95,    75,   126,    68,    98,    19,   107,   221,    95,   103,
      84,    98,    86,   107,   424,   125,    96,   111,   127,   125,
      34,    89,   432,   125,   434,   125,   124,   174,    96,   115,
     125,   125,   126,   247,    95,   126,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,    96,   152,   217,
      99,   131,    96,   230,   125,   393,   394,   106,   172,   108,
     126,   110,   531,   126,   417,    96,   130,    34,   126,   195,
     738,   130,   124,   177,   126,   201,    25,    26,   127,   128,
     124,    43,   186,   187,   188,   124,    43,   126,   324,   130,
      34,   321,   130,   124,    34,   124,   273,   126,    43,   568,
      78,    50,   522,   202,   218,    34,    34,   775,    96,   158,
      88,    99,     8,     9,    10,    11,    12,   221,    96,    98,
     126,    99,   110,   124,   132,   126,   230,   596,   106,   233,
     108,   235,   110,   237,   124,    98,   126,   124,    34,   127,
     128,    96,    34,   247,   613,    47,   615,    95,   125,   127,
     128,   504,   428,    34,    34,   127,   127,    34,   388,   512,
     390,     4,   123,   132,   132,   389,   126,   126,   132,   273,
     158,   328,   126,    61,    96,    34,   126,   334,   130,   126,
     158,   124,   412,   124,   382,    43,   606,   423,   418,    19,
     127,   611,   127,    46,   430,   603,   604,     8,     9,    10,
      11,    12,   180,    96,    98,    16,    17,    98,   127,    96,
      96,    66,    67,    96,    96,    26,    27,   316,    96,   130,
      31,    32,    33,    96,    96,    96,   511,    96,    39,   333,
      12,   516,    96,    15,    16,    17,    96,   341,    20,   343,
      51,    34,    96,     4,   348,    96,   476,   225,   425,    96,
      96,    62,    66,    67,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   368,    94,   365,   132,   123,   124,
     500,   126,    94,   128,   126,   131,   325,   728,   382,    95,
     384,   385,   558,    66,    67,   389,   131,    34,    43,   131,
     127,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   590,   536,    98,    18,   123,
     124,    52,   126,   130,   128,   419,   125,   132,    66,    67,
     131,   425,    95,   372,   554,   127,    96,   127,   127,   125,
     131,   561,   130,   116,   117,   118,   131,   325,   127,   443,
     123,   124,   391,   126,   132,   128,   132,   325,    66,    67,
     758,   132,     4,    52,   132,   127,    34,   126,    18,    89,
      18,   460,    98,   131,   562,   130,   130,   107,    24,   132,
     646,   601,    98,    66,    67,   123,   124,   131,   126,   132,
     128,   131,   107,   132,   372,   511,    34,   132,   127,   131,
     516,   517,    66,   623,   372,    66,    67,   523,   116,   117,
     118,    62,   131,   391,   508,   123,   124,    34,   126,   132,
     128,   132,   132,   391,    43,   464,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   132,    43,   477,   126,
     123,   124,    34,   126,   658,   128,   124,    43,   127,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   127,    96,
     576,    43,   123,   124,   127,   126,    96,   128,   562,    96,
      96,    66,    67,    96,   590,    96,    96,   385,    96,   569,
      96,   597,    96,    96,    96,    96,   464,    96,    96,   166,
     661,   585,   706,   696,   644,   589,   464,   760,   695,   477,
     616,   496,   466,   451,   551,   345,    97,   225,   454,   477,
      85,   614,    88,   518,   630,   525,   632,   731,    -1,   114,
     115,   116,   117,   118,    -1,   468,    -1,   694,   123,   124,
      -1,   126,   626,   128,    -1,    -1,    -1,    -1,   577,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   641,   642,    -1,
      -1,    -1,    -1,   592,    -1,   775,   650,   651,   652,   653,
     654,   655,    -1,   657,   658,    -1,    -1,   734,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,    -1,
      -1,    -1,    -1,   687,    -1,    -1,    -1,   691,    -1,   577,
     694,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   577,
      -1,    -1,   706,    -1,   592,    -1,    -1,    -1,    -1,    -1,
     659,   660,    -1,    -1,   592,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   731,    -1,    -1,
     734,   735,   736,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      67,   690,    -1,   692,    -1,    -1,   695,    -1,   697,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   761,   762,   763,
     764,   765,   766,   767,   768,   769,   770,   771,   772,   773,
     774,   659,   660,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   659,   660,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    -1,    -1,    -1,    -1,   123,   124,    -1,   126,
      -1,   128,   690,     4,   692,    -1,    -1,    -1,    -1,   697,
     759,    -1,   690,    -1,   692,    -1,    -1,   695,    -1,   697,
      -1,    -1,     3,    -1,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    17,    18,    19,    20,
      -1,    22,    23,    -1,    25,    26,    -1,    28,    29,    30,
      31,    52,    33,    34,    35,    36,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    66,    67,    48,    49,    50,
      -1,   759,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,   759,    63,    64,    65,    -1,    -1,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,    -1,
      -1,    -1,   123,   124,    -1,   126,    -1,   128,   109,    -1,
      -1,   132,    -1,   114,   115,    -1,   117,    -1,   119,   120,
     121,   122,   123,   124,    -1,   126,    -1,    -1,    -1,   130,
     131,   132,     3,    -1,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    17,    18,    19,    20,
      -1,    22,    23,    -1,    25,    26,    -1,    28,    29,    30,
      31,    -1,    33,    34,    35,    36,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    -1,    -1,    48,    49,    50,
      -1,    -1,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    -1,    -1,    68,    -1,    -1,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,    -1,
      -1,    -1,    -1,   114,   115,    -1,   117,    -1,   119,   120,
     121,   122,   123,   124,    -1,   126,    -1,    -1,    -1,   130,
     131,   132,     3,   132,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    17,    18,    19,    20,
      -1,    22,    23,    -1,    25,    26,    -1,    28,    29,    30,
      31,    -1,    33,    34,    35,    36,    37,    38,    -1,    40,
      41,    42,    -1,    44,    45,    66,    67,    48,    49,    50,
      -1,    -1,    53,    54,    55,    56,    57,    58,    59,    60,
      -1,    -1,    63,    64,    65,    -1,    -1,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    -1,    -1,
      -1,     4,   123,   124,    -1,   126,    -1,   128,   109,    -1,
      -1,    -1,    -1,   114,   115,    -1,   117,    -1,   119,   120,
     121,   122,   123,   124,     3,   126,     5,     6,    -1,   130,
      -1,   132,    -1,    -1,    13,    -1,    -1,    -1,    -1,    18,
      19,    20,    -1,    22,    23,    -1,    25,    -1,    -1,    52,
      29,    -1,    31,    -1,    33,    34,    -1,    36,    37,    38,
      -1,    -1,    41,    66,    67,    44,    45,    -1,    -1,    48,
       4,    50,    -1,    -1,    -1,    54,    55,    56,    57,    -1,
      59,    60,    -1,    -1,    63,    64,    -1,    -1,    -1,    68,
      -1,    -1,    -1,    96,    97,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,    -1,    52,    -1,
     123,   124,    -1,   126,    -1,   128,    -1,    -1,    -1,   132,
     109,    -1,    66,    67,    -1,   114,   115,    -1,   117,    -1,
     119,   120,   121,   122,   123,   124,    -1,   126,    -1,    -1,
      -1,    -1,    -1,   132,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,     3,    -1,     5,     6,   123,
     124,    -1,   126,    -1,   128,    13,    -1,    -1,   132,    -1,
      18,    19,    20,    -1,    22,    23,    -1,    25,    -1,    -1,
      -1,    29,    -1,    31,    -1,    33,    34,    -1,    36,    37,
      38,    66,    67,    41,    -1,    -1,    44,    45,    -1,    -1,
      48,    -1,    50,    -1,    -1,    -1,    54,    55,    56,    57,
      -1,    59,    60,    -1,    -1,    63,    -1,    -1,    -1,    -1,
      68,    -1,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    -1,    -1,    -1,    -1,   123,   124,
      -1,   126,    -1,   128,     4,    -1,    -1,    -1,    -1,    -1,
      -1,   109,    -1,    -1,    -1,    -1,   114,   115,    -1,   117,
      -1,   119,   120,   121,   122,   123,   124,     3,   126,     5,
       6,    -1,   130,    -1,    -1,    -1,    -1,    13,    -1,    -1,
      -1,    -1,    18,    19,    20,    -1,    22,    23,    -1,    25,
      -1,    -1,    52,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    -1,    -1,    41,    66,    67,    44,    45,
      -1,    -1,    48,     4,    50,    -1,    -1,    -1,    54,    55,
      56,    57,    -1,    59,    60,    -1,    -1,    63,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
      -1,    52,    -1,   123,   124,    -1,   126,    -1,   128,    -1,
     130,    -1,    -1,   109,    -1,    66,    67,    -1,   114,   115,
       4,   117,    -1,   119,   120,   121,   122,   123,   124,    -1,
     126,    -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    67,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    52,    -1,
      -1,    -1,   123,   124,    -1,   126,    -1,   128,    -1,   130,
      -1,    -1,    66,    67,    -1,    -1,    -1,     4,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,    -1,    -1,    -1,
     123,   124,    -1,   126,    -1,   128,    -1,    -1,    -1,    -1,
      66,    67,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    52,    -1,    -1,    -1,   123,
     124,    -1,   126,    -1,   128,    -1,   130,    -1,    -1,    66,
      67,    -1,    -1,    -1,     4,   111,   112,   113,   114,   115,
     116,   117,   118,    -1,    -1,    -1,    -1,   123,   124,    -1,
     126,    -1,   128,    -1,    -1,    -1,    66,    67,    -1,    96,
      97,    -1,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    52,    -1,    -1,    -1,   123,   124,    -1,   126,
     127,   128,    -1,    -1,    -1,    -1,    66,    67,    -1,    -1,
      -1,     4,   112,   113,   114,   115,   116,   117,   118,    -1,
      -1,    -1,    -1,   123,   124,    -1,   126,    -1,   128,    -1,
      -1,    -1,    -1,    66,    67,    -1,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    52,
      -1,    -1,    -1,   123,   124,    -1,   126,   127,   128,    -1,
      -1,    -1,    -1,    66,    67,    -1,    -1,    -1,     4,   112,
     113,   114,   115,   116,   117,   118,    -1,    -1,    -1,    -1,
     123,   124,    -1,   126,    -1,   128,    -1,    -1,    66,    67,
      -1,    -1,    -1,    96,    97,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    52,    -1,    -1,    -1,
     123,   124,    -1,   126,   127,   128,    -1,    -1,    -1,    -1,
      66,    67,    -1,    -1,    -1,     4,   114,   115,   116,   117,
     118,    -1,    -1,    -1,    -1,   123,   124,    -1,   126,    -1,
     128,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    52,    -1,    -1,    -1,   123,   124,    -1,
     126,    -1,   128,    -1,    -1,    -1,    -1,    66,    67,    -1,
      -1,    -1,     4,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      52,    -1,    -1,    -1,   123,   124,    -1,   126,    -1,   128,
      -1,    -1,    -1,    -1,    66,    67,    -1,    -1,    -1,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,    52,    -1,    -1,
      -1,   123,   124,    -1,   126,    -1,   128,    -1,    -1,    -1,
      -1,    66,    67,    -1,    -1,    -1,     4,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    96,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,    52,    -1,    -1,    -1,   123,   124,
      -1,   126,   127,   128,    -1,    -1,    -1,    -1,    66,    67,
      -1,    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    97,
      -1,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,    52,    -1,    -1,    -1,   123,   124,    -1,   126,   127,
     128,    -1,    -1,    -1,    -1,    66,    67,    -1,    -1,    -1,
       4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,    52,    -1,
      -1,    -1,   123,   124,    -1,   126,   127,   128,    -1,    -1,
      -1,    -1,    66,    67,    -1,    -1,    -1,     4,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    96,    97,    -1,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,    52,    -1,    -1,    -1,   123,
     124,    -1,   126,   127,   128,    -1,    -1,    -1,    -1,    66,
      67,    -1,    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      97,    -1,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,    52,    -1,    -1,    -1,   123,   124,    -1,   126,
     127,   128,    -1,    -1,    -1,    -1,    66,    67,    -1,    -1,
      -1,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    97,    -1,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    52,
      -1,    -1,    -1,   123,   124,    -1,   126,   127,   128,    -1,
      -1,    -1,    -1,    66,    67,    -1,    -1,    -1,     4,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    52,    -1,    -1,    -1,
     123,   124,    -1,   126,    -1,   128,    -1,    -1,    -1,    -1,
      66,    67,    -1,    -1,    -1,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,    52,    -1,    -1,    -1,   123,   124,    -1,
     126,    -1,   128,    -1,    -1,    -1,    -1,    66,    67,    -1,
      -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    97,    -1,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      52,    -1,    -1,    -1,   123,   124,    -1,   126,    -1,   128,
      -1,    -1,    -1,    -1,    66,    67,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    -1,    -1,    -1,    96,    97,    -1,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,     3,    -1,     5,
       6,   123,   124,    -1,   126,    -1,   128,    13,   131,    -1,
      -1,    -1,    18,    19,    20,    -1,    22,    23,    -1,    25,
      -1,    -1,    -1,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    66,    67,    41,    -1,    -1,    44,    45,
      -1,    -1,    48,    -1,    50,    -1,    -1,    -1,    54,    55,
      56,    57,    -1,    59,    60,    -1,    62,    63,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    -1,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,    -1,    -1,    -1,
     123,   124,    -1,   126,    -1,   128,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   109,    -1,    -1,    -1,    -1,   114,   115,
      -1,   117,    -1,   119,   120,   121,   122,   123,   124,     3,
     126,     5,     6,    -1,    -1,    -1,    -1,    -1,    -1,    13,
      -1,    -1,    -1,    -1,    18,    19,    20,    -1,    22,    23,
      -1,    25,    -1,    -1,    -1,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    -1,    -1,    41,    -1,    -1,
      44,    45,    -1,    -1,    48,    -1,    50,    -1,    -1,    -1,
      54,    55,    56,    57,    -1,    59,    60,    -1,    -1,    63,
      -1,    -1,    -1,    -1,    68,    -1,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,    -1,    -1,    -1,    -1,
     114,   115,    -1,   117,    -1,   119,   120,   121,   122,   123,
     124,     3,   126,     5,     6,    -1,    -1,    -1,   131,    -1,
      -1,    13,    -1,    -1,    -1,    -1,    18,    19,    20,    -1,
      22,    23,    -1,    25,    -1,    -1,    -1,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    66,    67,    41,
      -1,    -1,    44,    45,    -1,    -1,    48,    -1,    50,    -1,
      -1,    -1,    54,    55,    56,    57,    -1,    59,    60,    -1,
      -1,    63,    -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
      -1,    -1,    -1,    -1,   123,   124,    -1,   126,    -1,   128,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,    -1,    -1,
      -1,    -1,   114,   115,    -1,   117,    -1,   119,   120,   121,
     122,   123,   124,     3,   126,     5,     6,    -1,    -1,    -1,
      -1,    -1,    -1,    13,    -1,    -1,    -1,    -1,    18,    19,
      20,    -1,    22,    23,    -1,    25,    -1,    -1,    -1,    29,
      -1,    31,    -1,    33,    34,    -1,    36,    37,    38,    -1,
      -1,    41,    -1,    -1,    44,    45,    -1,    -1,    48,    -1,
      50,    -1,    -1,    -1,    54,    55,    56,    57,    -1,    59,
      60,    -1,    -1,    63,    -1,    -1,    -1,    -1,    68,    -1,
      -1,    -1,    -1,     5,     6,    -1,    -1,    -1,    -1,    -1,
      -1,    13,    -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,
      -1,    23,    -1,    25,    26,    -1,    -1,    29,    -1,    31,
      -1,    33,    34,    -1,    36,    37,    38,    -1,    -1,    -1,
      -1,    -1,    44,    45,    -1,    -1,    48,    -1,    50,   119,
     120,   121,   122,    55,    56,    57,    -1,    59,    60,     5,
       6,    63,    -1,    -1,    -1,    -1,    68,    13,    -1,    -1,
      -1,    -1,    -1,    -1,    20,    -1,    -1,    23,    -1,    25,
      26,    -1,    -1,    29,    -1,    31,    -1,    33,    34,    -1,
      36,    37,    38,    66,    67,    -1,    -1,    -1,    44,    45,
      -1,    -1,    48,    -1,    50,    -1,    -1,    -1,    -1,    55,
      56,    57,    -1,    59,    60,    -1,    -1,    63,    -1,    -1,
      -1,    -1,    68,    66,    67,    -1,    -1,    -1,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,    -1,    -1,    -1,
     123,   124,    -1,   126,    -1,   128,    66,    67,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,    -1,    -1,    -1,    -1,
     123,   124,    -1,   126,    -1,   128,    66,    67,    -1,    -1,
      -1,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
      -1,    -1,    -1,   123,   124,    -1,   126,    -1,   128,    -1,
      -1,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,    -1,
      -1,    -1,    -1,   123,   124,    -1,   126,    -1,   128,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    16,    17,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,    27,    -1,
      -1,    -1,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    62
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    93,   134,   137,   136,     0,     8,     9,    10,    11,
      12,    16,    17,    26,    27,    31,    32,    33,    39,    51,
      62,   135,   175,   187,   188,     3,     5,     6,    13,    18,
      19,    20,    22,    23,    25,    29,    31,    33,    34,    36,
      37,    38,    41,    44,    45,    48,    50,    54,    55,    56,
      57,    59,    60,    63,    68,   109,   114,   115,   117,   119,
     120,   121,   122,   123,   124,   126,   147,   164,   195,   208,
     232,   126,   126,   126,   225,   226,   225,   228,   229,   130,
     225,   225,   225,    34,    25,    26,    50,   223,   224,   225,
     214,   185,   147,   126,   147,   130,    43,   196,   154,    43,
      34,   222,    43,   126,   130,   147,   124,   126,   124,   126,
      43,   126,   147,   147,   147,   155,   147,   147,   147,   147,
      34,   147,   159,   160,   147,     4,    52,    66,    67,    96,
      97,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   123,   124,   126,   128,   147,    34,    34,    98,   203,
     223,   203,   126,   202,   230,   232,   176,   202,   203,   202,
     132,   223,   228,   223,   177,   230,    98,     7,    14,    17,
      26,    28,    30,    35,    40,    42,    49,    53,    58,    64,
      65,   130,   132,   139,   140,   141,   142,   147,   187,   208,
     212,   220,   186,   147,   167,    26,    31,    33,    50,    55,
      59,    63,   164,   168,   231,   232,   124,   197,   198,   147,
     168,    96,    34,   159,   165,   130,   168,   169,   160,   169,
     150,   168,   160,   109,    47,    96,   197,    95,   237,   125,
     127,   130,   147,   156,   156,   168,   168,   148,   147,   147,
     147,   147,   147,   147,   147,   147,   147,   147,   147,   147,
     147,   147,   147,   147,   147,   147,   147,   147,   147,    34,
     138,   147,   159,   152,    34,   127,   127,   127,   168,     4,
      52,    96,   204,   227,   204,    34,   172,   173,   174,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,   209,   210,   211,   137,   209,   204,   209,
       4,   202,   123,   181,   203,   184,   147,   132,   222,   215,
     232,   132,   126,   126,   222,   132,   159,    64,   132,   147,
     147,   126,   213,    61,   212,   124,   126,   132,    96,   212,
     130,   187,   189,   127,    34,   161,   162,   163,   126,   202,
     126,    19,   199,   200,   201,   186,   202,   156,    95,   127,
     170,   215,    95,   125,   127,   125,   160,   127,    46,   147,
      96,   147,   157,   156,    98,    98,   125,   160,   205,   206,
     205,    98,   127,    95,   132,    96,    96,    96,    96,    96,
      96,    96,    96,    96,    96,    96,    96,    96,    96,    96,
     211,   131,   205,   130,   209,    34,     4,   204,   168,    95,
     233,    94,   234,   203,   132,   126,   234,    34,   124,   147,
     203,   234,   132,   234,   132,   130,   147,    94,   235,   147,
     143,   199,   144,   145,   234,   147,   190,    89,    96,   236,
     131,    95,   172,   172,    95,   125,    34,   130,   192,   166,
     186,   131,   168,   209,    43,   127,   149,   158,   159,   147,
     138,   147,   153,   209,   156,   209,   168,    98,   174,   174,
     147,   147,   147,   147,   147,   147,   147,   147,   147,   147,
     147,   147,   147,   147,    18,   209,   178,   179,   180,   130,
     205,   209,   147,   132,   204,   234,   160,    95,   107,   221,
     222,   127,   204,   234,   234,   216,   127,   214,   130,   125,
     127,   147,   132,   214,    96,    18,   115,   163,   127,   127,
     200,   193,   131,    34,   171,   168,   151,   192,   131,   237,
     125,   127,   132,   207,   132,   209,   168,   132,   161,     4,
      52,   182,   209,   132,   205,   127,    34,   147,    95,   125,
     212,   205,    15,    21,   131,   217,   212,   131,   235,   126,
     146,   234,   191,    18,   236,    18,   214,    98,   209,   131,
     130,   130,   170,   132,   209,   107,   127,   222,    95,   107,
      24,   209,    62,   159,   218,   219,    98,   214,   144,   131,
     194,   168,   132,   210,   210,   183,   132,   147,    34,   147,
     212,   132,   168,    98,    95,    98,   214,   131,   127,   131,
     209,   131,   131,   131,   234,   127,   107,   127,   234,    66,
     214,   219,   214,   132,   132,   132,   209,   147,    34,   132,
     127,     3,    22,    29,    33,    38,    41,    55,    59,    63,
     114,   115,   119,   120,   121,   122,   123,     4,    52,    66,
      67,    96,    97,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   147,    31,    59,    63,    95,   147,   147,
      43,   154,    43,   222,   126,   124,   126,    43,   147,   147,
     147,   147,   147,   147,    34,   147,   148,   147,   147,   147,
     147,   147,   147,   147,   147,   147,   147,   147,   147,   147,
     147,   147,   147,   147,   147,   147,   147,   147,   126,   147,
     147,    96,   160,   169,   150,    96,    98,   172,   127,   125,
     160,   147,   147,   127,    69,    70,    71,    74,    75,    76,
      77,    78,    80,    81,    83,    84,    87,    88,   210,    43,
     127,    96,    96,    96,    96,    96,    96,    96,    96,    96,
      96,    96,    96,    96,    96,   151,   147,   147,   147,   147,
     147,   147,   147,   147,   147,   147,   147,   147,   147,   147
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,   133,   135,   134,   136,   134,   137,   137,   138,   138,
     139,   139,   140,   141,   141,   142,   142,   143,   143,   145,
     146,   144,   147,   147,   147,   147,   147,   147,   147,   147,
     147,   147,   147,   147,   147,   147,   147,   147,   147,   147,
     147,   147,   147,   147,   147,   147,   147,   147,   147,   147,
     147,   147,   147,   148,   147,   147,   147,   147,   147,   147,
     149,   147,   147,   147,   147,   147,   150,   151,   147,   147,
     147,   152,   153,   147,   154,   147,   147,   147,   147,   147,
     147,   147,   155,   147,   147,   147,   147,   157,   156,   156,
     158,   158,   159,   159,   160,   160,   161,   161,   162,   162,
     163,   163,   163,   164,   164,   164,   164,   164,   164,   164,
     164,   164,   164,   164,   164,   164,   164,   165,   166,   164,
     167,   164,   164,   164,   164,   164,   164,   164,   168,   168,
     168,   168,   168,   169,   169,   170,   170,   171,   172,   172,
     172,   173,   173,   173,   174,   175,   176,   175,   175,   175,
     175,   177,   175,   178,   175,   179,   175,   180,   175,   181,
     182,   183,   175,   184,   175,   185,   175,   175,   186,   186,
     187,   187,   187,   187,   187,   188,   188,   188,   188,   190,
     191,   189,   193,   194,   192,   196,   195,   197,   198,   198,
     199,   199,   200,   201,   201,   202,   202,   203,   203,   204,
     204,   204,   204,   206,   207,   205,   205,   208,   209,   209,
     210,   210,   211,   211,   211,   211,   211,   211,   211,   211,
     211,   211,   211,   211,   211,   211,   211,   211,   211,   211,
     211,   211,   211,   211,   211,   211,   211,   213,   212,   212,
     212,   212,   212,   212,   212,   212,   212,   212,   212,   212,
     212,   212,   212,   212,   212,   212,   212,   212,   212,   214,
     214,   215,   216,   216,   217,   217,   217,   218,   218,   219,
     219,   220,   220,   220,   220,   221,   221,   222,   224,   223,
     226,   227,   225,   229,   228,   230,   231,   232,   232,   233,
     233,   234,   234,   235,   235,   236,   236,   236,   237,   237
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     0,     3,     2,     0,     1,     0,
       7,     1,     2,     7,     4,     2,     1,     1,     0,     0,
       0,     3,     3,     4,     2,     2,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     5,     0,     4,     4,     4,     1,     3,     4,
       0,     6,     3,     3,     3,     4,     0,     0,     7,     5,
       4,     0,     0,     6,     0,     3,     3,     1,     5,     1,
       1,     1,     0,     4,     3,     3,     3,     0,     4,     1,
       2,     0,     3,     1,     2,     0,     1,     2,     1,     3,
       4,     4,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     6,     4,     0,     0,     6,
       0,     5,     1,     3,     3,     3,     1,     3,     1,     2,
       4,     4,     1,     3,     1,     3,     0,     5,     1,     2,
       0,     3,     3,     1,     4,     3,     0,     5,     7,     7,
       7,     0,     8,     0,     9,     0,    11,     0,    11,     0,
       0,     0,    12,     0,     7,     0,     4,     1,     0,     2,
       4,     4,     4,     1,     1,     4,     4,     4,     5,     0,
       0,     5,     0,     0,     5,     0,     5,     2,     3,     0,
       3,     1,     2,     1,     0,     5,     3,     2,     0,     0,
       1,     1,     1,     0,     0,     3,     0,     6,     1,     0,
       2,     1,     3,     3,     1,     1,     1,     1,     3,     3,
       3,     3,     1,     3,     3,     3,     3,     3,     1,     3,
       3,     3,     1,     1,     1,     3,     1,     0,     5,     4,
       4,     4,     5,     7,     5,     2,     5,     3,     3,     3,
       3,     4,     8,     8,     1,     5,     3,     1,     1,     2,
       0,     4,     2,     0,     4,     4,     3,     3,     1,     2,
       4,     6,     8,     8,    10,     3,     1,     1,     0,     2,
       0,     0,     3,     0,     2,     1,     1,     1,     1,     2,
       0,     1,     0,     1,     0,     1,     3,     0,     1,     0
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = zeeklex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 398 "/build/zeek/src/zeek/src/parse.y"
                        {
			// Without the following, in some scenarios the
			// location associated with global statements gets
			// associated with the last @load'd file rather than
			// the script that includes the global statements.
			auto loc = zeek::detail::GetCurrentLocation();
			if ( loc.filename )
				set_location(loc);
			}
#line 2786 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 3: /* zeek: decl_list $@1 stmt_list  */
#line 408 "/build/zeek/src/zeek/src/parse.y"
                        {
			if ( stmts )
				stmts->AsStmtList()->Stmts().push_back({AdoptRef{}, (yyvsp[0].stmt)});
			else
				stmts = (yyvsp[0].stmt);

			// Do some further validation on the parsed AST unless
			// we already know there were errors.
			if ( zeek::reporter->Errors() == 0 )
				zeek::detail::script_validation();

			// Any objects creates from here on out should not
			// have file positions associated with them.
			set_location(no_location);
			}
#line 2806 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 4: /* $@2: %empty  */
#line 427 "/build/zeek/src/zeek/src/parse.y"
                          { in_debug = true; }
#line 2812 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 5: /* zeek: TOK_DEBUG $@2 expr  */
#line 428 "/build/zeek/src/zeek/src/parse.y"
                        {
			g_curr_debug_expr = (yyvsp[0].expr);
			}
#line 2820 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 8: /* opt_expr: expr  */
#line 440 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = (yyvsp[0].expr); }
#line 2826 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 9: /* opt_expr: %empty  */
#line 442 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = 0; }
#line 2832 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 10: /* when_clause: when_head TOK_TIMEOUT expr '{' opt_no_test_block stmt_list '}'  */
#line 447 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-6]), (yylsp[0]));
			(yyvsp[-6].when_clause)->AddTimeout({AdoptRef{}, (yyvsp[-4].expr)}, {AdoptRef{}, (yyvsp[-1].stmt)});
			if ( (yyvsp[-2].b) )
			    script_coverage_mgr.DecIgnoreDepth();
			}
#line 2843 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 12: /* when_head: when_start stmt  */
#line 459 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyvsp[-1].when_clause)->AddBody({AdoptRef{}, (yyvsp[0].stmt)});
			}
#line 2852 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 13: /* when_start: when_flavor '[' when_captures ']' '(' when_condition ')'  */
#line 467 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-6]), (yylsp[0]));
			(yyval.when_clause) = new WhenInfo({AdoptRef{}, (yyvsp[-1].expr)}, (yyvsp[-4].captures), (yyvsp[-6].b));
			}
#line 2861 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 14: /* when_start: when_flavor '(' when_condition ')'  */
#line 473 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.when_clause) = new WhenInfo({AdoptRef{}, (yyvsp[-1].expr)}, nullptr, (yyvsp[-3].b));
			}
#line 2870 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 15: /* when_flavor: TOK_RETURN TOK_WHEN  */
#line 481 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.b) = true; }
#line 2876 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 16: /* when_flavor: TOK_WHEN  */
#line 484 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.b) = false; }
#line 2882 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 18: /* when_captures: %empty  */
#line 490 "/build/zeek/src/zeek/src/parse.y"
                { (yyval.captures) = new zeek::FuncType::CaptureList; }
#line 2888 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 19: /* $@3: %empty  */
#line 494 "/build/zeek/src/zeek/src/parse.y"
                { ++in_when_cond; }
#line 2894 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 20: /* $@4: %empty  */
#line 494 "/build/zeek/src/zeek/src/parse.y"
                                         { --in_when_cond; }
#line 2900 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 21: /* when_condition: $@3 expr $@4  */
#line 495 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = (yyvsp[-1].expr); }
#line 2906 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 22: /* expr: '(' expr ')'  */
#line 500 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = (yyvsp[-1].expr); (yyval.expr)->MarkParen();
			}
#line 2915 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 23: /* expr: TOK_COPY '(' expr ')'  */
#line 506 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new CloneExpr({AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 2924 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 24: /* expr: TOK_ADD expr  */
#line 512 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new AggrAddExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2933 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 25: /* expr: TOK_DELETE expr  */
#line 518 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new AggrDelExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2942 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 26: /* expr: TOK_INCR expr  */
#line 524 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new IncrExpr(EXPR_INCR, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2951 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 27: /* expr: TOK_DECR expr  */
#line 530 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new IncrExpr(EXPR_DECR, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2960 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 28: /* expr: '!' expr  */
#line 536 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new NotExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2969 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 29: /* expr: '~' expr  */
#line 542 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new ComplementExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2978 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 30: /* expr: '-' expr  */
#line 548 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new NegExpr({AdoptRef{}, (yyvsp[0].expr)});

			if ( ! (yyval.expr)->IsError() && (yyvsp[0].expr)->IsConst() )
				{
				auto v = (yyvsp[0].expr)->ExprVal();
				auto tag = v->GetType()->Tag();

				if ( tag == TYPE_COUNT )
					{
					auto c = v->AsCount();
					uint64_t int_max = static_cast<uint64_t>(INT64_MAX) + 1;

					if ( c <= int_max )
						{
						auto ce = new ConstExpr(val_mgr->Int(-c));
						Unref((yyval.expr));
						(yyval.expr) = ce;
						}
					else
						{
						(yyval.expr)->Error("literal is outside range of 'int' values");
						(yyval.expr)->SetError();
						}
					}
				else
					{
					auto ce = new ConstExpr((yyval.expr)->Eval(nullptr));
					Unref((yyval.expr));
					(yyval.expr) = ce;
					}
				}
			}
#line 3017 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 31: /* expr: '+' expr  */
#line 584 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new PosExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3026 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 32: /* expr: expr '+' expr  */
#line 590 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new AddExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3035 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 33: /* expr: expr TOK_ADD_TO rhs  */
#line 596 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));

			ExprPtr lhs = {AdoptRef{}, (yyvsp[-2].expr)};
			ExprPtr rhs = {AdoptRef{}, (yyvsp[0].expr)};
			auto tag1 = (yyvsp[-2].expr)->GetType()->Tag();

			if ( IsArithmetic((yyvsp[-2].expr)->GetType()->Tag()) )
				{
				// Script optimization assumes that each AST
				// node is distinct, hence the call to
				// Duplicate() here.
				ExprPtr sum = make_intrusive<AddExpr>(lhs->Duplicate(), rhs);

				if ( sum->GetType()->Tag() != tag1 )
					sum = make_intrusive<ArithCoerceExpr>(sum, tag1);

				(yyval.expr) = new AssignExpr(lhs, sum, false);
				}
			else
				(yyval.expr) = new AddToExpr(lhs, rhs);
			}
#line 3062 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 34: /* expr: expr '-' expr  */
#line 620 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new SubExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3071 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 35: /* expr: expr TOK_REMOVE_FROM rhs  */
#line 626 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));

			ExprPtr lhs = {AdoptRef{}, (yyvsp[-2].expr)};
			ExprPtr rhs = {AdoptRef{}, (yyvsp[0].expr)};
			auto tag1 = (yyvsp[-2].expr)->GetType()->Tag();

			if ( IsArithmetic(tag1) )
				{
				ExprPtr sum = make_intrusive<SubExpr>(lhs, rhs);

				if ( sum->GetType()->Tag() != tag1 )
					sum = make_intrusive<ArithCoerceExpr>(sum, tag1);

				(yyval.expr) = new AssignExpr(lhs, sum, false);
				}
			else
				(yyval.expr) = new RemoveFromExpr(lhs, rhs);
			}
#line 3095 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 36: /* expr: expr '*' expr  */
#line 647 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new TimesExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3104 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 37: /* expr: expr '/' expr  */
#line 653 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			if ( (yyvsp[-2].expr)->GetType()->Tag() == TYPE_ADDR )
				(yyval.expr) = new MaskExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			else
				(yyval.expr) = new DivideExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3116 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 38: /* expr: expr '%' expr  */
#line 662 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new ModExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3125 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 39: /* expr: expr '&' expr  */
#line 668 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_AND, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3134 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 40: /* expr: expr '|' expr  */
#line 674 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_OR, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3143 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 41: /* expr: expr '^' expr  */
#line 680 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_XOR, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3152 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 42: /* expr: expr TOK_LSHIFT expr  */
#line 686 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_LSHIFT, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3161 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 43: /* expr: expr TOK_RSHIFT expr  */
#line 692 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_RSHIFT, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3170 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 44: /* expr: expr TOK_AND_AND expr  */
#line 698 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BoolExpr(EXPR_AND_AND, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3179 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 45: /* expr: expr TOK_OR_OR expr  */
#line 704 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BoolExpr(EXPR_OR_OR, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3188 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 46: /* expr: expr TOK_EQ expr  */
#line 710 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new EqExpr(EXPR_EQ, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3197 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 47: /* expr: expr TOK_NE expr  */
#line 716 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new EqExpr(EXPR_NE, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3206 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 48: /* expr: expr '<' expr  */
#line 722 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_LT, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3215 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 49: /* expr: expr TOK_LE expr  */
#line 728 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_LE, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3224 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 50: /* expr: expr '>' expr  */
#line 734 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_GT, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3233 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 51: /* expr: expr TOK_GE expr  */
#line 740 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_GE, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3242 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 52: /* expr: expr '?' expr ':' expr  */
#line 746 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.expr) = new CondExpr({AdoptRef{}, (yyvsp[-4].expr)}, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3251 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 53: /* $@5: %empty  */
#line 752 "/build/zeek/src/zeek/src/parse.y"
                        {
			// Prevent usage of trailing commas on the left-hand
			// side of list expressions (e.g. in table inits).
			if ( (yyvsp[-1].expr)->Tag() == EXPR_LIST && expr_list_has_opt_comma )
				(yyvsp[-1].expr)->Error("incorrect syntax for list expression "
				          "on left-hand side of assignment: "
				          "trailing comma not allowed");
			}
#line 3264 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 54: /* expr: expr '=' $@5 rhs  */
#line 761 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[-1]));

			if ( (yyvsp[-3].expr)->Tag() == EXPR_INDEX && (yyvsp[-3].expr)->AsIndexExpr()->IsSlice() )
				reporter->Error("index slice assignment may not be used"
				                      " in arbitrary expression contexts, only"
				                      " as a statement");

			(yyval.expr) = get_assign_expr({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[0].expr)}, in_init).release();
			}
#line 3279 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 55: /* expr: TOK_WHEN_LOCAL local_id '=' rhs  */
#line 773 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			if ( ! locals_at_this_scope.empty() )
			       locals_at_this_scope.back().insert((yyvsp[-2].id));
			(yyval.expr) = add_and_assign_local({AdoptRef{}, (yyvsp[-2].id)}, {AdoptRef{}, (yyvsp[0].expr)},
			                                        val_mgr->True()).release();
			}
#line 3291 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 56: /* expr: expr '[' expr_list ']'  */
#line 782 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			if ( in_when_cond > 0 )
				(yyval.expr) = new IndexExprWhen({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[-1].list)});
			else
				(yyval.expr) = new IndexExpr({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[-1].list)});
			}
#line 3303 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 58: /* expr: expr '$' TOK_ID  */
#line 793 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new FieldExpr({AdoptRef{}, (yyvsp[-2].expr)}, (yyvsp[0].str));
			}
#line 3312 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 59: /* expr: '$' TOK_ID '=' expr  */
#line 799 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new FieldAssignExpr((yyvsp[-2].str), {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3321 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 60: /* $@6: %empty  */
#line 805 "/build/zeek/src/zeek/src/parse.y"
                        {
			func_hdr_location = (yylsp[-3]);
			(yyvsp[-1].id)->SetInferReturnType(true);
			}
#line 3330 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 61: /* expr: '$' TOK_ID begin_lambda '=' $@6 lambda_body  */
#line 810 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.expr) = new FieldAssignExpr((yyvsp[-4].str), IntrusivePtr{AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3338 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 62: /* expr: expr TOK_IN expr  */
#line 815 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new InExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3347 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 63: /* expr: expr TOK_NOT_IN expr  */
#line 821 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new NotExpr(make_intrusive<InExpr>(
			        ExprPtr{AdoptRef{}, (yyvsp[-2].expr)},
			        ExprPtr{AdoptRef{}, (yyvsp[0].expr)}));
			}
#line 3358 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 64: /* expr: '[' opt_expr_list ']'  */
#line 829 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));

			bool is_record_ctor = true;

			// If every expression in the list is a field assignment,
			// then treat it as a record constructor, else as a list
			// used for an initializer. Interpret no expressions
			// as an empty record constructor.

			for ( int i = 0; i < (yyvsp[-1].list)->Exprs().length(); ++i )
				{
				if ( (yyvsp[-1].list)->Exprs()[i]->Tag() != EXPR_FIELD_ASSIGN )
					{
					is_record_ctor = false;
					break;
					}
				}

			if ( is_record_ctor )
				(yyval.expr) = new RecordConstructorExpr({AdoptRef{}, (yyvsp[-1].list)});
			else
				(yyval.expr) = (yyvsp[-1].list);
			}
#line 3387 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 65: /* expr: TOK_RECORD '(' expr_list ')'  */
#line 855 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new RecordConstructorExpr({AdoptRef{}, (yyvsp[-1].list)});
			}
#line 3396 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 66: /* $@7: %empty  */
#line 860 "/build/zeek/src/zeek/src/parse.y"
                              { ++in_init; }
#line 3402 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 67: /* $@8: %empty  */
#line 860 "/build/zeek/src/zeek/src/parse.y"
                                                               { --in_init; }
#line 3408 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 68: /* expr: TOK_TABLE '(' $@7 opt_expr_list ')' $@8 opt_attr  */
#line 862 "/build/zeek/src/zeek/src/parse.y"
                        { // the ++in_init fixes up the parsing of "[x] = y"
			set_location((yylsp[-6]), (yylsp[-2]));
			std::unique_ptr<std::vector<AttrPtr>> attrs{(yyvsp[0].attr_l)};
			(yyval.expr) = new TableConstructorExpr({AdoptRef{}, (yyvsp[-3].list)}, std::move(attrs));
			}
#line 3418 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 69: /* expr: TOK_SET '(' opt_expr_list ')' opt_attr  */
#line 869 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[-1]));
			std::unique_ptr<std::vector<AttrPtr>> attrs{(yyvsp[0].attr_l)};
			(yyval.expr) = new SetConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, std::move(attrs));
			}
#line 3428 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 70: /* expr: TOK_VECTOR '(' opt_expr_list ')'  */
#line 876 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new VectorConstructorExpr({AdoptRef{}, (yyvsp[-1].list)});
			}
#line 3437 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 71: /* $@9: %empty  */
#line 882 "/build/zeek/src/zeek/src/parse.y"
                        {
			if ( expr_is_table_type_name((yyvsp[-1].expr)) )
				++in_init;
			}
#line 3446 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 72: /* $@10: %empty  */
#line 888 "/build/zeek/src/zeek/src/parse.y"
                        {
			if ( expr_is_table_type_name((yyvsp[-3].expr)) )
				--in_init;
			}
#line 3455 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 73: /* expr: expr '(' $@9 opt_expr_list $@10 ')'  */
#line 894 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-5]), (yylsp[0]));

			if ( (yyvsp[-5].expr)->Tag() == EXPR_NAME && (yyvsp[-5].expr)->AsNameExpr()->Id()->IsType() )
				{
				const auto& ctor_type = (yyvsp[-5].expr)->AsNameExpr()->Id()->GetType();

				switch ( ctor_type->Tag() ) {
				case TYPE_RECORD:
					{
					auto rt = cast_intrusive<RecordType>(ctor_type);
					(yyval.expr) = new RecordConstructorExpr(rt, ListExprPtr{AdoptRef{}, (yyvsp[-2].list)});
					}
					break;

				case TYPE_TABLE:
					if ( ctor_type->IsTable() )
						(yyval.expr) = new TableConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, 0, ctor_type);
					else
						(yyval.expr) = new SetConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, 0, ctor_type);

					break;

				case TYPE_VECTOR:
					(yyval.expr) = new VectorConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, ctor_type);
					break;

				default:
					(yyvsp[-5].expr)->Error("constructor type not implemented");
					YYERROR;
				}
				}

			else
				(yyval.expr) = new CallExpr({AdoptRef{}, (yyvsp[-5].expr)}, {AdoptRef{}, (yyvsp[-2].list)}, in_hook > 0, in_when_cond);
			}
#line 3496 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 74: /* $@11: %empty  */
#line 931 "/build/zeek/src/zeek/src/parse.y"
                         { ++in_hook; }
#line 3502 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 75: /* expr: TOK_HOOK $@11 expr  */
#line 932 "/build/zeek/src/zeek/src/parse.y"
                        {
			--in_hook;
			set_location((yylsp[-2]), (yylsp[0]));

			if ( (yyvsp[0].expr)->Tag() != EXPR_CALL )
				(yyvsp[0].expr)->Error("not a valid hook call expression");
			else if ( (yyvsp[0].expr)->AsCallExpr()->Func()->GetType()->AsFuncType()->Flavor() != FUNC_FLAVOR_HOOK )
				(yyvsp[0].expr)->Error("hook keyword should only be used to call hooks");

			(yyval.expr) = (yyvsp[0].expr);
			}
#line 3518 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 76: /* expr: expr TOK_HAS_FIELD TOK_ID  */
#line 945 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new HasFieldExpr({AdoptRef{}, (yyvsp[-2].expr)}, (yyvsp[0].str));
			}
#line 3527 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 78: /* expr: TOK_SCHEDULE expr '{' event '}'  */
#line 953 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.expr) = new ScheduleExpr({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[-1].event_expr)});
			}
#line 3536 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 79: /* expr: lookup_identifier  */
#line 959 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());

			if ( ! id )
				{
				if ( ! in_debug )
					{
/*	// CHECK THAT THIS IS NOT GLOBAL.
					id = install_ID($1, current_module.c_str(),
							        false, is_export);
*/

					yyerror(util::fmt("unknown identifier %s", (yyvsp[0].str)));
					YYERROR;
					}
				else
					{
					yyerror(util::fmt("unknown identifier %s", (yyvsp[0].str)));
					YYERROR;
					}
				}
			else
				{
				if ( id->IsDeprecated() )
					reporter->Deprecation(id->GetDeprecationWarning());

				if ( id->IsBlank() )
					{
					(yyval.expr) = new NameExpr(std::move(id));
					(yyval.expr)->SetError("blank identifier used in expression");
					}
				else if ( ! id->GetType() )
					{
					id->Error("undeclared variable");
					id->SetType(error_type());
					(yyval.expr) = new NameExpr(std::move(id));
					}

				else if ( id->IsEnumConst() )
					{
					if ( IsErrorType(id->GetType()->Tag()) )
						{
						// The most-relevant error message should already be reported, so
						// just bail out.
						YYERROR;
						}

					EnumType* t = id->GetType()->AsEnumType();
					auto intval = t->Lookup(id->ModuleName(), id->Name());
					if ( intval < 0 )
						reporter->InternalError("enum value not found for %s", id->Name());
					(yyval.expr) = new ConstExpr(t->GetEnumVal(intval));
					}
				else
					{
					if ( out_of_scope_locals.count(id.get()) > 0 )
						id->Error("use of out-of-scope local; move declaration to outer scope");

					(yyval.expr) = new NameExpr(std::move(id));
					}
				}
			}
#line 3604 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 80: /* expr: TOK_CONSTANT  */
#line 1024 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]));
			(yyval.expr) = new ConstExpr({AdoptRef{}, (yyvsp[0].val)});
			}
#line 3613 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 81: /* expr: simple_type  */
#line 1030 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]));
			TypePtr ty{AdoptRef(), (yyvsp[0].type)};
			(yyval.expr) = new ConstExpr(make_intrusive<TypeVal>(ty, true));
			}
#line 3623 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 82: /* $@12: %empty  */
#line 1036 "/build/zeek/src/zeek/src/parse.y"
                    { begin_RE(); }
#line 3629 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 83: /* expr: '/' $@12 TOK_PATTERN_TEXT TOK_PATTERN_END  */
#line 1037 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]));

			auto* re = new RE_Matcher((yyvsp[-1].str));
			delete [] (yyvsp[-1].str);

			if ( (yyvsp[0].re_modes).ignore_case )
				re->MakeCaseInsensitive();

			if ( (yyvsp[0].re_modes).single_line )
				re->MakeSingleLine();

			re->Compile();
			(yyval.expr) = new ConstExpr(make_intrusive<PatternVal>(re));
			}
#line 3649 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 84: /* expr: '|' expr '|'  */
#line 1054 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			ExprPtr e{AdoptRef{}, (yyvsp[-1].expr)};
			(yyval.expr) = new SizeExpr(std::move(e));
			}
#line 3659 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 85: /* expr: expr TOK_AS type  */
#line 1061 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new CastExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].type)});
			}
#line 3668 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 86: /* expr: expr TOK_IS type  */
#line 1067 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new IsExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].type)});
			}
#line 3677 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 87: /* $@13: %empty  */
#line 1073 "/build/zeek/src/zeek/src/parse.y"
                    { ++in_init; }
#line 3683 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 88: /* rhs: '{' $@13 rhs_expr_list '}'  */
#line 1074 "/build/zeek/src/zeek/src/parse.y"
                        {
			--in_init;
			(yyval.expr) = (yyvsp[-1].list);
			}
#line 3692 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 91: /* rhs_expr_list: %empty  */
#line 1083 "/build/zeek/src/zeek/src/parse.y"
                { (yyval.list) = new ListExpr(); }
#line 3698 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 92: /* expr_list: expr_list ',' expr  */
#line 1088 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyvsp[-2].list)->Append({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3707 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 93: /* expr_list: expr  */
#line 1094 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]));
			expr_list_has_opt_comma = 0;
			(yyval.list) = new ListExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3717 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 95: /* opt_expr_list: %empty  */
#line 1104 "/build/zeek/src/zeek/src/parse.y"
                { (yyval.list) = new ListExpr(); }
#line 3723 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 96: /* enum_body: enum_body_list  */
#line 1109 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.type) = cur_enum_type;
			cur_enum_type = nullptr;
			}
#line 3732 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 97: /* enum_body: enum_body_list ','  */
#line 1115 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.type) = cur_enum_type;
			cur_enum_type = nullptr;
			}
#line 3741 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 100: /* enum_body_elem: TOK_ID '=' TOK_CONSTANT opt_deprecated  */
#line 1134 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[-1]));
			assert(cur_enum_type);

			if ( (yyvsp[-1].val)->GetType()->Tag() != TYPE_COUNT )
				reporter->Error("enumerator is not a count constant");
			else
				cur_enum_type->AddName(current_module, (yyvsp[-3].str),
				                       (yyvsp[-1].val)->InternalUnsigned(), is_export, (yyvsp[0].expr),
				                       in_enum_redef != 0);
			}
#line 3757 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 101: /* enum_body_elem: TOK_ID '=' '-' TOK_CONSTANT  */
#line 1147 "/build/zeek/src/zeek/src/parse.y"
                        {
			// We only accept counts as enumerator, but we want to return a nice
			// error message if users try to use a negative integer (will also
			// catch other cases, but that's fine.)
			reporter->Error("enumerator is not a count constant");
			}
#line 3768 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 102: /* enum_body_elem: TOK_ID opt_deprecated  */
#line 1155 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]));
			assert(cur_enum_type);
			cur_enum_type->AddName(current_module, (yyvsp[-1].str), is_export, (yyvsp[0].expr),
			                       in_enum_redef != 0);
			}
#line 3779 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 103: /* simple_type: TOK_BOOL  */
#line 1165 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_BOOL)->Ref();
				}
#line 3788 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 104: /* simple_type: TOK_INT  */
#line 1171 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_INT)->Ref();
				}
#line 3797 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 105: /* simple_type: TOK_COUNT  */
#line 1177 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_COUNT)->Ref();
				}
#line 3806 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 106: /* simple_type: TOK_DOUBLE  */
#line 1183 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_DOUBLE)->Ref();
				}
#line 3815 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 107: /* simple_type: TOK_TIME  */
#line 1189 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_TIME)->Ref();
				}
#line 3824 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 108: /* simple_type: TOK_INTERVAL  */
#line 1195 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_INTERVAL)->Ref();
				}
#line 3833 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 109: /* simple_type: TOK_STRING  */
#line 1201 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_STRING)->Ref();
				}
#line 3842 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 110: /* simple_type: TOK_PATTERN  */
#line 1207 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_PATTERN)->Ref();
				}
#line 3851 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 111: /* simple_type: TOK_PORT  */
#line 1213 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_PORT)->Ref();
				}
#line 3860 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 112: /* simple_type: TOK_ADDR  */
#line 1219 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_ADDR)->Ref();
				}
#line 3869 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 113: /* simple_type: TOK_SUBNET  */
#line 1225 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_SUBNET)->Ref();
				}
#line 3878 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 114: /* simple_type: TOK_ANY  */
#line 1231 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_ANY)->Ref();
				}
#line 3887 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 115: /* simple_type: TOK_TABLE '[' type_list ']' TOK_OF type  */
#line 1237 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-5]), (yylsp[0]));
				(yyval.type) = new TableType({AdoptRef{}, (yyvsp[-3].type_l)}, {AdoptRef{}, (yyvsp[0].type)});
				}
#line 3896 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 116: /* simple_type: TOK_SET '[' type_list ']'  */
#line 1243 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-3]), (yylsp[0]));
				(yyval.type) = new SetType({AdoptRef{}, (yyvsp[-1].type_l)}, nullptr);
				}
#line 3905 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 117: /* $@14: %empty  */
#line 1249 "/build/zeek/src/zeek/src/parse.y"
                        { ++in_record; }
#line 3911 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 118: /* $@15: %empty  */
#line 1251 "/build/zeek/src/zeek/src/parse.y"
                        { --in_record; }
#line 3917 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 119: /* simple_type: TOK_RECORD '{' $@14 type_decl_list $@15 '}'  */
#line 1253 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-5]), (yylsp[-1]));
				(yyval.type) = new RecordType((yyvsp[-2].type_decl_l));
				}
#line 3926 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 120: /* $@16: %empty  */
#line 1258 "/build/zeek/src/zeek/src/parse.y"
                             { set_location((yylsp[-1])); parse_new_enum(); }
#line 3932 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 121: /* simple_type: TOK_ENUM '{' $@16 enum_body '}'  */
#line 1259 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-4]), (yylsp[0]));
				(yyvsp[-1].type)->UpdateLocationEndInfo((yylsp[0]));
				(yyval.type) = (yyvsp[-1].type);
				}
#line 3942 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 122: /* simple_type: TOK_LIST  */
#line 1266 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				// $$ = new TypeList();
				reporter->Error("list type not implemented");
				(yyval.type) = 0;
				}
#line 3953 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 123: /* simple_type: TOK_LIST TOK_OF type  */
#line 1274 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-2]));
				// $$ = new TypeList($3);
				reporter->Error("list type not implemented");
				(yyval.type) = 0;
				}
#line 3964 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 124: /* simple_type: TOK_VECTOR TOK_OF type  */
#line 1282 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new VectorType({AdoptRef{}, (yyvsp[0].type)});
				}
#line 3973 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 125: /* simple_type: TOK_FILE TOK_OF type  */
#line 1288 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new FileType({AdoptRef{}, (yyvsp[0].type)});
				}
#line 3982 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 126: /* simple_type: TOK_FILE  */
#line 1294 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = new FileType(base_type(TYPE_STRING));
				}
#line 3991 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 127: /* simple_type: TOK_OPAQUE TOK_OF TOK_ID  */
#line 1300 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new OpaqueType((yyvsp[0].str));
				}
#line 4000 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 129: /* type: TOK_FUNCTION func_params  */
#line 1308 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-1]), (yylsp[0]));
				(yyval.type) = (yyvsp[0].func_type);
				}
#line 4009 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 130: /* type: TOK_HOOK '(' formal_args ')'  */
#line 1314 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-3]), (yylsp[-1]));
				(yyval.type) = new FuncType({AdoptRef{}, (yyvsp[-1].record)}, base_type(TYPE_BOOL), FUNC_FLAVOR_HOOK);
				}
#line 4018 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 131: /* type: TOK_EVENT '(' formal_args ')'  */
#line 1320 "/build/zeek/src/zeek/src/parse.y"
                                {
				set_location((yylsp[-3]), (yylsp[-1]));
				(yyval.type) = new FuncType({AdoptRef{}, (yyvsp[-1].record)}, nullptr, FUNC_FLAVOR_EVENT);
				}
#line 4027 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 132: /* type: resolve_id  */
#line 1326 "/build/zeek/src/zeek/src/parse.y"
                        {
			if ( ! (yyvsp[0].id) || ! ((yyval.type) = (yyvsp[0].id)->IsType() ? (yyvsp[0].id)->GetType().get() : nullptr) )
				{
				NullStmt here;
				if ( (yyvsp[0].id) )
					(yyvsp[0].id)->Error("not a Zeek type", &here);
				(yyval.type) = error_type()->Ref();
				}
			else
				{
				Ref((yyval.type));

				if ( (yyvsp[0].id)->IsDeprecated() )
					reporter->Deprecation((yyvsp[0].id)->GetDeprecationWarning());
				}
			}
#line 4048 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 133: /* type_list: type_list ',' type  */
#line 1346 "/build/zeek/src/zeek/src/parse.y"
                        { (yyvsp[-2].type_l)->AppendEvenIfNotPure({AdoptRef{}, (yyvsp[0].type)}); }
#line 4054 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 134: /* type_list: type  */
#line 1348 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.type_l) = new TypeList({NewRef{}, (yyvsp[0].type)});
			(yyval.type_l)->Append({AdoptRef{}, (yyvsp[0].type)});
			}
#line 4063 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 135: /* type_decl_list: type_decl_list conditional_list type_decl  */
#line 1356 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyvsp[-2].type_decl_l)->push_back((yyvsp[0].type_decl));
			}
#line 4071 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 136: /* type_decl_list: %empty  */
#line 1360 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.type_decl_l) = new type_decl_list();
			}
#line 4079 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 137: /* type_decl: TOK_ID ':' type opt_attr ';'  */
#line 1367 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[-1]));
			auto attrs = make_attributes((yyvsp[-1].attr_l), {NewRef{}, (yyvsp[-2].type)}, in_record > 0, false);
			(yyval.type_decl) = new TypeDecl((yyvsp[-4].str), {AdoptRef{}, (yyvsp[-2].type)}, std::move(attrs));

			if ( in_record > 0 && cur_decl_type_id )
				zeekygen_mgr->RecordField(cur_decl_type_id, (yyval.type_decl), ::filename,
				                                        in_record_redef != 0);
			}
#line 4093 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 138: /* formal_args: formal_args_decl_list  */
#line 1380 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.record) = new RecordType((yyvsp[0].type_decl_l)); }
#line 4099 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 139: /* formal_args: formal_args_decl_list ';'  */
#line 1382 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.record) = new RecordType((yyvsp[-1].type_decl_l)); }
#line 4105 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 140: /* formal_args: %empty  */
#line 1384 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.record) = new RecordType(new type_decl_list()); }
#line 4111 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 141: /* formal_args_decl_list: formal_args_decl_list ';' formal_args_decl  */
#line 1389 "/build/zeek/src/zeek/src/parse.y"
                        { (yyvsp[-2].type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 4117 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 142: /* formal_args_decl_list: formal_args_decl_list ',' formal_args_decl  */
#line 1391 "/build/zeek/src/zeek/src/parse.y"
                        { (yyvsp[-2].type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 4123 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 143: /* formal_args_decl_list: formal_args_decl  */
#line 1393 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.type_decl_l) = new type_decl_list(); (yyval.type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 4129 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 144: /* formal_args_decl: TOK_ID ':' type opt_attr  */
#line 1398 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			auto attrs = make_attributes((yyvsp[0].attr_l), {NewRef{}, (yyvsp[-1].type)}, true, false);
			(yyval.type_decl) = new TypeDecl((yyvsp[-3].str), {AdoptRef{}, (yyvsp[-1].type)}, std::move(attrs));
			}
#line 4139 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 145: /* decl: TOK_MODULE TOK_ID ';'  */
#line 1407 "/build/zeek/src/zeek/src/parse.y"
                        {
			current_module = (yyvsp[-1].str);
			zeek::detail::add_module((yyvsp[-1].str));
			zeekygen_mgr->ModuleUsage(::filename, current_module);
			}
#line 4149 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 146: /* $@17: %empty  */
#line 1413 "/build/zeek/src/zeek/src/parse.y"
                               { is_export = true; }
#line 4155 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 147: /* decl: TOK_EXPORT '{' $@17 decl_list '}'  */
#line 1414 "/build/zeek/src/zeek/src/parse.y"
                        { is_export = false; }
#line 4161 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 148: /* decl: TOK_GLOBAL def_global_id opt_type init_class opt_init opt_attr ';'  */
#line 1417 "/build/zeek/src/zeek/src/parse.y"
                        {
			build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_REGULAR);
			}
#line 4169 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 149: /* decl: TOK_OPTION def_global_id opt_type init_class opt_init opt_attr ';'  */
#line 1422 "/build/zeek/src/zeek/src/parse.y"
                        {
			if ( (yyvsp[-5].id)->IsBlank() )
				(yyvsp[-5].id)->Error("blank identifier used as option");
			else
				build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_OPTION);
			}
#line 4180 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 150: /* decl: TOK_CONST def_global_id opt_type init_class opt_init opt_attr ';'  */
#line 1430 "/build/zeek/src/zeek/src/parse.y"
                        {
			build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_CONST);
			}
#line 4188 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 151: /* $@18: %empty  */
#line 1434 "/build/zeek/src/zeek/src/parse.y"
                                    {
			if ( (yyvsp[0].id)->IsType() )
				{
				auto tag = (yyvsp[0].id)->GetType()->Tag();
				auto tstr = type_name(tag);
				if ( tag == TYPE_RECORD || tag == TYPE_ENUM )
					yyerror(zeek::util::fmt("redef of %s type %s is missing %s keyword",
								tstr, (yyvsp[0].id)->Name(), tstr));
				else
					yyerror(zeek::util::fmt("can not redef %s type %s", tstr, (yyvsp[0].id)->Name()));

				YYERROR;  // bail
				}
		}
#line 4207 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 152: /* decl: TOK_REDEF global_id $@18 opt_type init_class opt_init opt_attr ';'  */
#line 1448 "/build/zeek/src/zeek/src/parse.y"
                        {
			build_global((yyvsp[-6].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_REDEF);
			}
#line 4215 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 153: /* $@19: %empty  */
#line 1453 "/build/zeek/src/zeek/src/parse.y"
                        { ++in_enum_redef; parse_redef_enum((yyvsp[-2].id)); zeekygen_mgr->Redef((yyvsp[-2].id), ::filename); }
#line 4221 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 154: /* decl: TOK_REDEF TOK_ENUM global_id TOK_ADD_TO '{' $@19 enum_body '}' ';'  */
#line 1455 "/build/zeek/src/zeek/src/parse.y"
                        {
			--in_enum_redef;
			// Zeekygen already grabbed new enum IDs as the type created them.
			}
#line 4230 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 155: /* $@20: %empty  */
#line 1461 "/build/zeek/src/zeek/src/parse.y"
                        { cur_decl_type_id = (yyvsp[-2].id); zeekygen_mgr->Redef((yyvsp[-2].id), ::filename, INIT_EXTRA); }
#line 4236 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 156: /* decl: TOK_REDEF TOK_RECORD global_id '$' TOK_ID $@20 TOK_ADD_TO '{' attr_list '}' ';'  */
#line 1463 "/build/zeek/src/zeek/src/parse.y"
                        {
			cur_decl_type_id = 0;
			parse_redef_record_field((yyvsp[-8].id), (yyvsp[-6].str), INIT_EXTRA, std::unique_ptr<std::vector<AttrPtr>>((yyvsp[-2].attr_l)));
			}
#line 4245 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 157: /* $@21: %empty  */
#line 1468 "/build/zeek/src/zeek/src/parse.y"
                        { cur_decl_type_id = (yyvsp[-2].id); zeekygen_mgr->Redef((yyvsp[-2].id), ::filename, INIT_REMOVE); }
#line 4251 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 158: /* decl: TOK_REDEF TOK_RECORD global_id '$' TOK_ID $@21 TOK_REMOVE_FROM '{' attr_list '}' ';'  */
#line 1470 "/build/zeek/src/zeek/src/parse.y"
                        {
			cur_decl_type_id = 0;
			parse_redef_record_field((yyvsp[-8].id), (yyvsp[-6].str), INIT_REMOVE, std::unique_ptr<std::vector<AttrPtr>>((yyvsp[-2].attr_l)));
			}
#line 4260 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 159: /* $@22: %empty  */
#line 1475 "/build/zeek/src/zeek/src/parse.y"
                        { cur_decl_type_id = (yyvsp[0].id); zeekygen_mgr->Redef((yyvsp[0].id), ::filename); }
#line 4266 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 160: /* $@23: %empty  */
#line 1477 "/build/zeek/src/zeek/src/parse.y"
                        { ++in_record; ++in_record_redef; }
#line 4272 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 161: /* $@24: %empty  */
#line 1479 "/build/zeek/src/zeek/src/parse.y"
                        { --in_record; --in_record_redef; }
#line 4278 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 162: /* decl: TOK_REDEF TOK_RECORD global_id $@22 TOK_ADD_TO '{' $@23 type_decl_list $@24 '}' opt_attr ';'  */
#line 1481 "/build/zeek/src/zeek/src/parse.y"
                        {
			cur_decl_type_id = 0;

			if ( ! (yyvsp[-9].id)->GetType() )
				(yyvsp[-9].id)->Error("unknown identifier");
			else
				extend_record((yyvsp[-9].id), std::unique_ptr<type_decl_list>((yyvsp[-4].type_decl_l)),
				              std::unique_ptr<std::vector<AttrPtr>>((yyvsp[-1].attr_l)));
			}
#line 4292 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 163: /* $@25: %empty  */
#line 1492 "/build/zeek/src/zeek/src/parse.y"
                        { cur_decl_type_id = (yyvsp[-1].id); zeekygen_mgr->StartType({NewRef{}, (yyvsp[-1].id)});  }
#line 4298 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 164: /* decl: TOK_TYPE def_global_id ':' $@25 type opt_attr ';'  */
#line 1494 "/build/zeek/src/zeek/src/parse.y"
                        {
			cur_decl_type_id = 0;
			IntrusivePtr id{AdoptRef{}, (yyvsp[-5].id)};
			add_type(id.get(), {AdoptRef{}, (yyvsp[-2].type)},
			                       std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[-1].attr_l)});
			zeekygen_mgr->Identifier(std::move(id));
			}
#line 4310 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 165: /* $@26: %empty  */
#line 1503 "/build/zeek/src/zeek/src/parse.y"
                        {
			func_hdr_location = (yylsp[0]);
			func_hdr_cond_epoch = conditional_epoch;
			}
#line 4319 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 170: /* conditional: TOK_ATIF '(' expr ')'  */
#line 1518 "/build/zeek/src/zeek/src/parse.y"
                        { do_atif((yyvsp[-1].expr)); }
#line 4325 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 171: /* conditional: TOK_ATIFDEF '(' TOK_ID ')'  */
#line 1520 "/build/zeek/src/zeek/src/parse.y"
                        { do_atifdef((yyvsp[-1].str)); }
#line 4331 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 172: /* conditional: TOK_ATIFNDEF '(' TOK_ID ')'  */
#line 1522 "/build/zeek/src/zeek/src/parse.y"
                        { do_atifndef((yyvsp[-1].str)); }
#line 4337 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 173: /* conditional: TOK_ATENDIF  */
#line 1524 "/build/zeek/src/zeek/src/parse.y"
                        { do_atendif(); }
#line 4343 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 174: /* conditional: TOK_ATELSE  */
#line 1526 "/build/zeek/src/zeek/src/parse.y"
                        { do_atelse(); }
#line 4349 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 175: /* func_hdr: TOK_FUNCTION def_global_id func_params opt_attr  */
#line 1531 "/build/zeek/src/zeek/src/parse.y"
                        {
			IntrusivePtr id{AdoptRef{}, (yyvsp[-2].id)};
			begin_func(id, current_module.c_str(),
				                     FUNC_FLAVOR_FUNCTION, false, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			zeekygen_mgr->Identifier(std::move(id));
			}
#line 4362 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 176: /* func_hdr: TOK_EVENT event_id func_params opt_attr  */
#line 1540 "/build/zeek/src/zeek/src/parse.y"
                        {
			begin_func({NewRef{}, (yyvsp[-2].id)}, current_module.c_str(),
				                     FUNC_FLAVOR_EVENT, false, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 4373 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 177: /* func_hdr: TOK_HOOK def_global_id func_params opt_attr  */
#line 1547 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyvsp[-1].func_type)->ClearYieldType(FUNC_FLAVOR_HOOK);
			(yyvsp[-1].func_type)->SetYieldType(base_type(TYPE_BOOL));
			begin_func({NewRef{}, (yyvsp[-2].id)}, current_module.c_str(),
				                     FUNC_FLAVOR_HOOK, false, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 4386 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 178: /* func_hdr: TOK_REDEF TOK_EVENT event_id func_params opt_attr  */
#line 1556 "/build/zeek/src/zeek/src/parse.y"
                        {
			begin_func({NewRef{}, (yyvsp[-2].id)}, current_module.c_str(),
				                     FUNC_FLAVOR_EVENT, true, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 4397 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 179: /* $@27: %empty  */
#line 1566 "/build/zeek/src/zeek/src/parse.y"
                        {
			saved_in_init.push_back(in_init);
			in_init = 0;

			locals_at_this_scope.clear();
			out_of_scope_locals.clear();
			}
#line 4409 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 180: /* $@28: %empty  */
#line 1575 "/build/zeek/src/zeek/src/parse.y"
                        {
			in_init = saved_in_init.back();
			saved_in_init.pop_back();
			}
#line 4418 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 181: /* func_body: '{' $@27 stmt_list $@28 '}'  */
#line 1581 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location(func_hdr_location, (yylsp[0]));

			bool free_of_conditionals = true;
			if ( current_file_has_conditionals ||
			     conditional_epoch > func_hdr_cond_epoch )
				free_of_conditionals = false;

			end_func({AdoptRef{}, (yyvsp[-2].stmt)}, current_module.c_str(), free_of_conditionals);
			}
#line 4433 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 182: /* $@29: %empty  */
#line 1595 "/build/zeek/src/zeek/src/parse.y"
                        {
			saved_in_init.push_back(in_init);
			in_init = 0;
			}
#line 4442 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 183: /* $@30: %empty  */
#line 1601 "/build/zeek/src/zeek/src/parse.y"
                        {
			in_init = saved_in_init.back();
			saved_in_init.pop_back();
			}
#line 4451 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 184: /* lambda_body: '{' $@29 stmt_list $@30 '}'  */
#line 1607 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[0]));

			// Code duplication here is sad but needed.
			// end_func actually instantiates the function
			// and associates it with an ID. We perform that
			// association later and need to return a lambda
			// expression.

			// Gather the ingredients for a Func from the
			// current scope.
			auto ingredients = std::make_shared<FunctionIngredients>(
				current_scope(), IntrusivePtr{AdoptRef{}, (yyvsp[-2].stmt)}, current_module.c_str());
			auto outer_ids = gather_outer_ids(pop_scope(), ingredients->Body());

			(yyval.expr) = new LambdaExpr(std::move(ingredients), std::move(outer_ids));
			}
#line 4473 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 185: /* $@31: %empty  */
#line 1628 "/build/zeek/src/zeek/src/parse.y"
                        {
			// "is_export" is used in some contexts to determine
			// whether a given newly seen identifier is a global.
			// We're about parse a lambda body, for which all of
			// the new identifiers should be locals, not globals,
			// so we need to turn off "is_export" here.  We use
			// a stack because lambdas can have additional lambdas
			// inside their bodies.
			hold_is_export.push_back(is_export);
			is_export = false;
			}
#line 4489 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 186: /* anonymous_function: TOK_FUNCTION $@31 begin_lambda conditional_list lambda_body  */
#line 1640 "/build/zeek/src/zeek/src/parse.y"
                        {
			is_export = hold_is_export.back();
			hold_is_export.pop_back();
			(yyval.expr) = (yyvsp[0].expr);
			}
#line 4499 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 187: /* begin_lambda: opt_captures func_params  */
#line 1649 "/build/zeek/src/zeek/src/parse.y"
                        {
			auto id = current_scope()->GenerateTemporary("anonymous-function");
			begin_func(id, current_module.c_str(), FUNC_FLAVOR_FUNCTION, false, {AdoptRef{}, (yyvsp[0].func_type)});

			std::optional<FuncType::CaptureList> captures;

			if ( (yyvsp[-1].captures) )
				{
				captures = *(yyvsp[-1].captures);
				delete (yyvsp[-1].captures);
				}

			(yyvsp[0].func_type)->SetCaptures(std::move(captures));
			(yyval.id) = id.release();
			}
#line 4519 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 188: /* opt_captures: '[' capture_list ']'  */
#line 1668 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.captures) = (yyvsp[-1].captures); }
#line 4525 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 189: /* opt_captures: %empty  */
#line 1670 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.captures) = nullptr; }
#line 4531 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 190: /* capture_list: capture_list ',' capture  */
#line 1675 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyvsp[-2].captures)->push_back(*(yyvsp[0].capture));
			delete (yyvsp[0].capture);
			}
#line 4540 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 191: /* capture_list: capture  */
#line 1680 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.captures) = new zeek::FuncType::CaptureList;
			(yyval.captures)->push_back(*(yyvsp[0].capture));
			delete (yyvsp[0].capture);
			}
#line 4550 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 192: /* capture: opt_deep TOK_ID  */
#line 1689 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());

			if ( ! id )
				reporter->Error("no such local identifier: %s", (yyvsp[0].str));
			else if ( id->IsType() )
				{
				reporter->Error("cannot specify type in capture: %s", (yyvsp[0].str));
				id = nullptr;
				}
			else if ( id->IsGlobal() )
				{
				reporter->Error("cannot specify global in capture: %s", (yyvsp[0].str));
				id = nullptr;
				}

			delete [] (yyvsp[0].str);

			(yyval.capture) = new FuncType::Capture(id, (yyvsp[-1].b));
			}
#line 4576 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 193: /* opt_deep: TOK_COPY  */
#line 1713 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.b) = true; }
#line 4582 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 194: /* opt_deep: %empty  */
#line 1715 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.b) = false; }
#line 4588 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 195: /* func_params: '(' formal_args ')' ':' type  */
#line 1720 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.func_type) = new FuncType({AdoptRef{}, (yyvsp[-3].record)}, {AdoptRef{}, (yyvsp[0].type)}, FUNC_FLAVOR_FUNCTION); }
#line 4594 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 196: /* func_params: '(' formal_args ')'  */
#line 1722 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.func_type) = new FuncType({AdoptRef{}, (yyvsp[-1].record)}, base_type(TYPE_VOID), FUNC_FLAVOR_FUNCTION); }
#line 4600 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 197: /* opt_type: ':' type  */
#line 1727 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.type) = (yyvsp[0].type); }
#line 4606 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 198: /* opt_type: %empty  */
#line 1729 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.type) = 0; }
#line 4612 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 199: /* init_class: %empty  */
#line 1733 "/build/zeek/src/zeek/src/parse.y"
                                { (yyval.ic) = INIT_NONE; }
#line 4618 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 200: /* init_class: '='  */
#line 1734 "/build/zeek/src/zeek/src/parse.y"
                                { (yyval.ic) = INIT_FULL; }
#line 4624 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 201: /* init_class: TOK_ADD_TO  */
#line 1735 "/build/zeek/src/zeek/src/parse.y"
                                { (yyval.ic) = INIT_EXTRA; }
#line 4630 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 202: /* init_class: TOK_REMOVE_FROM  */
#line 1736 "/build/zeek/src/zeek/src/parse.y"
                                { (yyval.ic) = INIT_REMOVE; }
#line 4636 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 203: /* $@32: %empty  */
#line 1740 "/build/zeek/src/zeek/src/parse.y"
                { ++in_init; }
#line 4642 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 204: /* $@33: %empty  */
#line 1740 "/build/zeek/src/zeek/src/parse.y"
                                   { --in_init; }
#line 4648 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 205: /* opt_init: $@32 rhs $@33  */
#line 1741 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = (yyvsp[-1].expr); }
#line 4654 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 206: /* opt_init: %empty  */
#line 1743 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = 0; }
#line 4660 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 207: /* index_slice: expr '[' opt_expr ':' opt_expr ']'  */
#line 1748 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-5]), (yylsp[0]));

			auto low = (yyvsp[-3].expr) ? ExprPtr{AdoptRef{}, (yyvsp[-3].expr)} :
			                make_intrusive<ConstExpr>(val_mgr->Count(0));

			auto high = (yyvsp[-1].expr) ? ExprPtr{AdoptRef{}, (yyvsp[-1].expr)} :
			                 make_intrusive<SizeExpr>(
			                     ExprPtr{NewRef{}, (yyvsp[-5].expr)});

			if ( ! IsIntegral(low->GetType()->Tag()) || ! IsIntegral(high->GetType()->Tag()) )
				reporter->Error("slice notation must have integral values as indexes");

			auto le = make_intrusive<ListExpr>(std::move(low));
			le->Append(std::move(high));

			if ( in_when_cond > 0  )
				(yyval.expr) = new IndexExprWhen({AdoptRef{}, (yyvsp[-5].expr)}, std::move(le), true);
			else
				(yyval.expr) = new IndexExpr({AdoptRef{}, (yyvsp[-5].expr)}, std::move(le), true);
			}
#line 4686 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 209: /* opt_attr: %empty  */
#line 1773 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr_l) = nullptr; }
#line 4692 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 210: /* attr_list: attr_list attr  */
#line 1778 "/build/zeek/src/zeek/src/parse.y"
                        { (yyvsp[-1].attr_l)->emplace_back(AdoptRef{}, (yyvsp[0].attr)); }
#line 4698 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 211: /* attr_list: attr  */
#line 1780 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.attr_l) = new std::vector<AttrPtr>;
			(yyval.attr_l)->emplace_back(AdoptRef{}, (yyvsp[0].attr));
			}
#line 4707 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 212: /* attr: TOK_ATTR_DEFAULT '=' expr  */
#line 1788 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_DEFAULT, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4713 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 213: /* attr: TOK_ATTR_DEFAULT_INSERT '=' expr  */
#line 1790 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_DEFAULT_INSERT, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4719 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 214: /* attr: TOK_ATTR_OPTIONAL  */
#line 1792 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_OPTIONAL); }
#line 4725 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 215: /* attr: TOK_ATTR_REDEF  */
#line 1794 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_REDEF); }
#line 4731 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 216: /* attr: TOK_ATTR_IS_ASSIGNED  */
#line 1796 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_IS_ASSIGNED); }
#line 4737 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 217: /* attr: TOK_ATTR_IS_USED  */
#line 1798 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_IS_USED); }
#line 4743 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 218: /* attr: TOK_ATTR_ADD_FUNC '=' expr  */
#line 1800 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_ADD_FUNC, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4749 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 219: /* attr: TOK_ATTR_DEL_FUNC '=' expr  */
#line 1802 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_DEL_FUNC, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4755 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 220: /* attr: TOK_ATTR_ON_CHANGE '=' expr  */
#line 1804 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_ON_CHANGE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4761 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 221: /* attr: TOK_ATTR_BROKER_STORE '=' expr  */
#line 1806 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_BROKER_STORE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4767 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 222: /* attr: TOK_ATTR_BROKER_STORE_ALLOW_COMPLEX  */
#line 1808 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_BROKER_STORE_ALLOW_COMPLEX); }
#line 4773 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 223: /* attr: TOK_ATTR_BACKEND '=' expr  */
#line 1810 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_BACKEND, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4779 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 224: /* attr: TOK_ATTR_EXPIRE_FUNC '=' expr  */
#line 1812 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_EXPIRE_FUNC, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4785 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 225: /* attr: TOK_ATTR_EXPIRE_CREATE '=' expr  */
#line 1814 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_EXPIRE_CREATE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4791 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 226: /* attr: TOK_ATTR_EXPIRE_READ '=' expr  */
#line 1816 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_EXPIRE_READ, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4797 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 227: /* attr: TOK_ATTR_EXPIRE_WRITE '=' expr  */
#line 1818 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_EXPIRE_WRITE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4803 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 228: /* attr: TOK_ATTR_RAW_OUTPUT  */
#line 1820 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_RAW_OUTPUT); }
#line 4809 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 229: /* attr: TOK_ATTR_PRIORITY '=' expr  */
#line 1822 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_PRIORITY, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4815 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 230: /* attr: TOK_ATTR_GROUP '=' expr  */
#line 1824 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_GROUP, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4821 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 231: /* attr: TOK_ATTR_TYPE_COLUMN '=' expr  */
#line 1826 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_TYPE_COLUMN, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4827 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 232: /* attr: TOK_ATTR_LOG  */
#line 1828 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_LOG); }
#line 4833 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 233: /* attr: TOK_ATTR_ERROR_HANDLER  */
#line 1830 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_ERROR_HANDLER); }
#line 4839 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 234: /* attr: TOK_ATTR_DEPRECATED  */
#line 1832 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_DEPRECATED); }
#line 4845 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 235: /* attr: TOK_ATTR_DEPRECATED '=' TOK_CONSTANT  */
#line 1834 "/build/zeek/src/zeek/src/parse.y"
                        {
			if ( IsString((yyvsp[0].val)->GetType()->Tag()) )
				(yyval.attr) = new Attr(
					ATTR_DEPRECATED,
					make_intrusive<ConstExpr>(IntrusivePtr{AdoptRef{}, (yyvsp[0].val)}));
			else
				{
				ODesc d;
				(yyvsp[0].val)->Describe(&d);
				Unref((yyvsp[0].val));
				reporter->Error("'&deprecated=%s' must use a string literal",
				                      d.Description());
				(yyval.attr) = new Attr(ATTR_DEPRECATED);
				}
			}
#line 4865 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 236: /* attr: TOK_ATTR_ORDERED  */
#line 1850 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.attr) = new Attr(ATTR_ORDERED); }
#line 4871 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 237: /* $@34: %empty  */
#line 1855 "/build/zeek/src/zeek/src/parse.y"
                        {
			std::set<const ID*> id_set;
			locals_at_this_scope.emplace_back(id_set);
			}
#line 4880 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 238: /* stmt: '{' $@34 opt_no_test_block stmt_list '}'  */
#line 1860 "/build/zeek/src/zeek/src/parse.y"
                        {
			auto& scope_locals = locals_at_this_scope.back();
			out_of_scope_locals.insert(scope_locals.begin(), scope_locals.end());
			locals_at_this_scope.pop_back();

			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.stmt) = (yyvsp[-1].stmt);
			if ( (yyvsp[-2].b) )
			    script_coverage_mgr.DecIgnoreDepth();
			}
#line 4895 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 239: /* stmt: TOK_ASSERT expr opt_assert_msg ';'  */
#line 1872 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.stmt) = new AssertStmt(IntrusivePtr{AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 4903 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 240: /* stmt: TOK_PRINT expr_list ';' opt_no_test  */
#line 1877 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new PrintStmt(IntrusivePtr{AdoptRef{}, (yyvsp[-2].list)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4914 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 241: /* stmt: TOK_EVENT event ';' opt_no_test  */
#line 1885 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new EventStmt({AdoptRef{}, (yyvsp[-2].event_expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4925 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 242: /* stmt: TOK_IF '(' expr ')' stmt  */
#line 1893 "/build/zeek/src/zeek/src/parse.y"
                        {
			reject_directive((yyvsp[0].stmt));
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.stmt) = new IfStmt({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].stmt)}, make_intrusive<NullStmt>());
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4936 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 243: /* stmt: TOK_IF '(' expr ')' stmt TOK_ELSE stmt  */
#line 1901 "/build/zeek/src/zeek/src/parse.y"
                        {
			reject_directive((yyvsp[-2].stmt));
			reject_directive((yyvsp[0].stmt));
			set_location((yylsp[-6]), (yylsp[-3]));
			(yyval.stmt) = new IfStmt({AdoptRef{}, (yyvsp[-4].expr)}, {AdoptRef{}, (yyvsp[-2].stmt)}, {AdoptRef{}, (yyvsp[0].stmt)});
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4948 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 244: /* stmt: TOK_SWITCH expr '{' case_list '}'  */
#line 1910 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[-3]));
			(yyval.stmt) = new SwitchStmt({AdoptRef{}, (yyvsp[-3].expr)}, (yyvsp[-1].case_l));
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4958 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 245: /* stmt: for_head stmt  */
#line 1917 "/build/zeek/src/zeek/src/parse.y"
                        {
			reject_directive((yyvsp[0].stmt));
			(yyvsp[-1].stmt)->AsForStmt()->AddBody({AdoptRef{}, (yyvsp[0].stmt)});
			script_coverage_mgr.AddStmt((yyvsp[-1].stmt));
			}
#line 4968 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 246: /* stmt: TOK_WHILE '(' expr ')' stmt  */
#line 1924 "/build/zeek/src/zeek/src/parse.y"
                        {
			reject_directive((yyvsp[0].stmt));
			(yyval.stmt) = new WhileStmt({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].stmt)});
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4978 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 247: /* stmt: TOK_NEXT ';' opt_no_test  */
#line 1931 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new NextStmt;
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4989 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 248: /* stmt: TOK_BREAK ';' opt_no_test  */
#line 1939 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new BreakStmt;
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 5000 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 249: /* stmt: TOK_FALLTHROUGH ';' opt_no_test  */
#line 1947 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new FallthroughStmt;
			if ( ! (yyvsp[0].b) )
				script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 5011 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 250: /* stmt: TOK_RETURN ';' opt_no_test  */
#line 1955 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new ReturnStmt(0);
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 5022 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 251: /* stmt: TOK_RETURN expr ';' opt_no_test  */
#line 1963 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[-2]));
			(yyval.stmt) = new ReturnStmt({AdoptRef{}, (yyvsp[-2].expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 5033 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 252: /* stmt: TOK_LOCAL local_id opt_type init_class opt_init opt_attr ';' opt_no_test  */
#line 1971 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-7]), (yylsp[-1]));
			if ( ! locals_at_this_scope.empty() )
			       locals_at_this_scope.back().insert((yyvsp[-6].id));
			(yyval.stmt) = build_local((yyvsp[-6].id), (yyvsp[-5].type), (yyvsp[-4].ic), (yyvsp[-3].expr), (yyvsp[-2].attr_l), VAR_REGULAR, ! (yyvsp[0].b)).release();
			}
#line 5044 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 253: /* stmt: TOK_CONST local_id opt_type init_class opt_init opt_attr ';' opt_no_test  */
#line 1979 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-7]), (yylsp[-2]));

			(yyval.stmt) = build_local((yyvsp[-6].id), (yyvsp[-5].type), (yyvsp[-4].ic), (yyvsp[-3].expr), (yyvsp[-2].attr_l), VAR_CONST, ! (yyvsp[0].b)).release();
			}
#line 5054 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 254: /* stmt: when_clause  */
#line 1986 "/build/zeek/src/zeek/src/parse.y"
                        {
			std::shared_ptr<WhenInfo> wi((yyvsp[0].when_clause));
			(yyval.stmt) = new WhenStmt(std::move(wi));
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 5064 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 255: /* stmt: index_slice '=' expr ';' opt_no_test  */
#line 1993 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.stmt) = new ExprStmt(get_assign_expr({AdoptRef{}, (yyvsp[-4].expr)},
			                                  {AdoptRef{}, (yyvsp[-2].expr)}, in_init));

			if ( ! (yyvsp[0].b) )
				script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 5077 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 256: /* stmt: expr ';' opt_no_test  */
#line 2003 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new ExprStmt({AdoptRef{}, (yyvsp[-2].expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 5088 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 257: /* stmt: ';'  */
#line 2011 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]), (yylsp[0]));
			(yyval.stmt) = new NullStmt;
			script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 5098 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 258: /* stmt: conditional  */
#line 2018 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.stmt) = new NullStmt(true /* is_directive */); }
#line 5104 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 259: /* stmt_list: stmt_list stmt  */
#line 2023 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyvsp[-1].stmt)->AsStmtList()->Stmts().push_back({AdoptRef{}, (yyvsp[0].stmt)});
			(yyvsp[-1].stmt)->UpdateLocationEndInfo((yylsp[0]));
			}
#line 5114 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 260: /* stmt_list: %empty  */
#line 2029 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.stmt) = new StmtList(); }
#line 5120 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 261: /* event: lookup_identifier '(' opt_expr_list ')'  */
#line 2034 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			const auto& id = lookup_ID((yyvsp[-3].str), current_module.c_str());

			if ( id )
				{
				if ( ! id->IsGlobal() )
					{
					yyerror(util::fmt("local identifier \"%s\" cannot be used to reference an event", (yyvsp[-3].str)));
					YYERROR;
					}

				if ( id->IsDeprecated() )
					reporter->Deprecation(id->GetDeprecationWarning());

				(yyval.event_expr) = new EventExpr(id->Name(), {AdoptRef{}, (yyvsp[-1].list)});
				}
			else
				{
				(yyval.event_expr) = new EventExpr((yyvsp[-3].str), {AdoptRef{}, (yyvsp[-1].list)});
				}
			}
#line 5147 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 262: /* case_list: case_list case  */
#line 2060 "/build/zeek/src/zeek/src/parse.y"
                        { (yyvsp[-1].case_l)->push_back((yyvsp[0].c_case)); }
#line 5153 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 263: /* case_list: %empty  */
#line 2062 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.case_l) = new case_list; }
#line 5159 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 264: /* case: TOK_CASE expr_list ':' stmt_list  */
#line 2067 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.c_case) = new Case({AdoptRef{}, (yyvsp[-2].list)}, nullptr, {AdoptRef{}, (yyvsp[0].stmt)}); }
#line 5165 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 265: /* case: TOK_CASE case_type_list ':' stmt_list  */
#line 2070 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.c_case) = new Case(nullptr, (yyvsp[-2].id_l), {AdoptRef{}, (yyvsp[0].stmt)}); }
#line 5171 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 266: /* case: TOK_DEFAULT ':' stmt_list  */
#line 2073 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.c_case) = new Case(nullptr, nullptr, {AdoptRef{}, (yyvsp[0].stmt)}); }
#line 5177 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 267: /* case_type_list: case_type_list ',' case_type  */
#line 2078 "/build/zeek/src/zeek/src/parse.y"
                        { (yyvsp[-2].id_l)->push_back((yyvsp[0].id)); }
#line 5183 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 268: /* case_type_list: case_type  */
#line 2081 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.id_l) = new IDPList;
			(yyval.id_l)->push_back((yyvsp[0].id));
			}
#line 5192 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 269: /* case_type: TOK_TYPE type  */
#line 2089 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.id) = new ID(0, SCOPE_FUNCTION, false);
			(yyval.id)->SetType({AdoptRef{}, (yyvsp[0].type)});
			}
#line 5201 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 270: /* case_type: TOK_TYPE type TOK_AS TOK_ID  */
#line 2095 "/build/zeek/src/zeek/src/parse.y"
                        {
			const char* name = (yyvsp[0].str);
			TypePtr type{AdoptRef{}, (yyvsp[-2].type)};
			auto case_var = lookup_ID(name, current_module.c_str());

			if ( case_var && case_var->IsGlobal() )
				case_var->Error("already a global identifier");
			else
				case_var = install_ID(name, current_module.c_str(), false, false);

			add_local(case_var, std::move(type), INIT_NONE, nullptr, nullptr,
			                        VAR_REGULAR);
			(yyval.id) = case_var.release();
			}
#line 5220 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 271: /* for_head: TOK_FOR '(' TOK_ID TOK_IN expr ')'  */
#line 2112 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-5]), (yylsp[0]));

			// This rule needs to be separate from the loop
			// body so that we execute these actions - defining
			// the local variable - prior to parsing the body,
			// which might refer to the variable.
			auto loop_var = lookup_ID((yyvsp[-3].str), current_module.c_str());

			if ( loop_var )
				check_loop_var(loop_var);
			else
				{
				loop_var = install_ID((yyvsp[-3].str), current_module.c_str(),
				                                    false, false);
				}

			auto* loop_vars = new IDPList;
			loop_vars->push_back(loop_var.release());

			(yyval.stmt) = new ForStmt(loop_vars, {AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 5247 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 272: /* for_head: TOK_FOR '(' '[' local_id_list ']' TOK_IN expr ')'  */
#line 2136 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.stmt) = new ForStmt((yyvsp[-4].id_l), {AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 5255 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 273: /* for_head: TOK_FOR '(' TOK_ID ',' TOK_ID TOK_IN expr ')'  */
#line 2141 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-7]), (yylsp[0]));
			const char* module = current_module.c_str();

			// Check for previous definitions of key and
			// value variables.
			auto key_var = lookup_ID((yyvsp[-5].str), module);
			auto val_var = lookup_ID((yyvsp[-3].str), module);

			// Validate previous definitions as needed.
			if ( key_var )
				check_loop_var(key_var);
			else
				key_var = install_ID((yyvsp[-5].str), module, false, false);

			if ( val_var )
				check_loop_var(val_var);
			else
				val_var = install_ID((yyvsp[-3].str), module, false, false);

			auto* loop_vars = new IDPList;
			loop_vars->push_back(key_var.release());

			(yyval.stmt) = new ForStmt(loop_vars, {AdoptRef{}, (yyvsp[-1].expr)}, std::move(val_var));
			}
#line 5285 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 274: /* for_head: TOK_FOR '(' '[' local_id_list ']' ',' TOK_ID TOK_IN expr ')'  */
#line 2168 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[-9]), (yylsp[0]));
			const char* module = current_module.c_str();

			// Validate value variable
			auto val_var = lookup_ID((yyvsp[-3].str), module);

			if ( val_var )
				check_loop_var(val_var);
			else
				val_var = install_ID((yyvsp[-3].str), module, false, false);

			(yyval.stmt) = new ForStmt((yyvsp[-6].id_l), {AdoptRef{}, (yyvsp[-1].expr)}, std::move(val_var));
			}
#line 5304 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 275: /* local_id_list: local_id_list ',' local_id  */
#line 2186 "/build/zeek/src/zeek/src/parse.y"
                        { (yyvsp[-2].id_l)->push_back((yyvsp[0].id)); }
#line 5310 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 276: /* local_id_list: local_id  */
#line 2188 "/build/zeek/src/zeek/src/parse.y"
                        {
			(yyval.id_l) = new IDPList;
			(yyval.id_l)->push_back((yyvsp[0].id));
			}
#line 5319 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 277: /* local_id: TOK_ID  */
#line 2196 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());
			(yyval.id) = id.release();

			if ( (yyval.id) )
				{
				if ( (yyval.id)->IsGlobal() && ! (yyval.id)->IsBlank() )
					(yyval.id)->Error("already a global identifier");

				if ( (yyval.id)->IsConst() && ! (yyval.id)->IsBlank() )
 					(yyval.id)->Error("already a const identifier");

				delete [] (yyvsp[0].str);
				}

			else
				{
				(yyval.id) = install_ID((yyvsp[0].str), current_module.c_str(),
				                              false, false).release();
				}
			}
#line 5346 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 278: /* $@35: %empty  */
#line 2221 "/build/zeek/src/zeek/src/parse.y"
        { resolving_global_ID = true; }
#line 5352 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 279: /* global_id: $@35 global_or_event_id  */
#line 2222 "/build/zeek/src/zeek/src/parse.y"
                { (yyval.id) = (yyvsp[0].id); }
#line 5358 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 280: /* $@36: %empty  */
#line 2226 "/build/zeek/src/zeek/src/parse.y"
        { defining_global_ID = true; }
#line 5364 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 281: /* $@37: %empty  */
#line 2226 "/build/zeek/src/zeek/src/parse.y"
                                                 { defining_global_ID = false; }
#line 5370 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 282: /* def_global_id: $@36 global_id $@37  */
#line 2227 "/build/zeek/src/zeek/src/parse.y"
                { (yyval.id) = (yyvsp[-1].id); }
#line 5376 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 283: /* $@38: %empty  */
#line 2231 "/build/zeek/src/zeek/src/parse.y"
        { resolving_global_ID = false; }
#line 5382 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 284: /* event_id: $@38 global_or_event_id  */
#line 2232 "/build/zeek/src/zeek/src/parse.y"
                { (yyval.id) = (yyvsp[0].id); }
#line 5388 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 285: /* global_or_event_id: lookup_identifier  */
#line 2237 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str(), false,
			                    defining_global_ID);
			(yyval.id) = id.release();

			if ( (yyval.id) )
				{
				if ( ! (yyval.id)->IsGlobal() )
					(yyval.id)->Error("already a local identifier");

				if ( (yyval.id)->IsDeprecated() )
					{
					const auto& t = (yyval.id)->GetType();

					if ( t->Tag() != TYPE_FUNC ||
					     t->AsFuncType()->Flavor() != FUNC_FLAVOR_FUNCTION )
						reporter->Deprecation((yyval.id)->GetDeprecationWarning());
					}

				refine_location((yyval.id));
				delete [] (yyvsp[0].str);
				}

			else
				{
				const char* module_name =
					resolving_global_ID ?
						current_module.c_str() : 0;

				(yyval.id) = install_ID((yyvsp[0].str), module_name,
				                              true, is_export).release();
				}
			}
#line 5427 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 286: /* resolve_id: lookup_identifier  */
#line 2276 "/build/zeek/src/zeek/src/parse.y"
                        {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());
			(yyval.id) = id.release();

			if ( ! (yyval.id) )
				reporter->Error("identifier not defined: %s", (yyvsp[0].str));

			delete [] (yyvsp[0].str);
			}
#line 5442 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 288: /* lookup_identifier: TOK_GLOBAL_ID  */
#line 2292 "/build/zeek/src/zeek/src/parse.y"
                        {
			if ( is_export )
				{
				reporter->Error("cannot use :: prefix in export section: %s", (yyvsp[0].str));
				YYERROR;
				}
			}
#line 5454 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 289: /* opt_assert_msg: ',' expr  */
#line 2304 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = (yyvsp[0].expr); }
#line 5460 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 290: /* opt_assert_msg: %empty  */
#line 2306 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = nullptr; }
#line 5466 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 291: /* opt_no_test: TOK_NO_TEST  */
#line 2311 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.b) = true; }
#line 5472 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 292: /* opt_no_test: %empty  */
#line 2313 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.b) = false; }
#line 5478 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 293: /* opt_no_test_block: TOK_NO_TEST  */
#line 2318 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.b) = true; script_coverage_mgr.IncIgnoreDepth(); }
#line 5484 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 294: /* opt_no_test_block: %empty  */
#line 2320 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.b) = false; }
#line 5490 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 295: /* opt_deprecated: TOK_ATTR_DEPRECATED  */
#line 2325 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = new ConstExpr(make_intrusive<StringVal>("")); }
#line 5496 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 296: /* opt_deprecated: TOK_ATTR_DEPRECATED '=' TOK_CONSTANT  */
#line 2328 "/build/zeek/src/zeek/src/parse.y"
                        {
			if ( IsString((yyvsp[0].val)->GetType()->Tag()) )
				(yyval.expr) = new ConstExpr({AdoptRef{}, (yyvsp[0].val)});
			else
				{
				ODesc d;
				(yyvsp[0].val)->Describe(&d);
				reporter->Error("'&deprecated=%s' must use a string literal",
				                      d.Description());
				(yyval.expr) = new ConstExpr(make_intrusive<StringVal>(""));
				}
			}
#line 5513 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 297: /* opt_deprecated: %empty  */
#line 2341 "/build/zeek/src/zeek/src/parse.y"
                        { (yyval.expr) = nullptr; }
#line 5519 "/build/zeek/src/zeek/build/src/p.cc"
    break;

  case 298: /* expr_list_opt_comma: ','  */
#line 2344 "/build/zeek/src/zeek/src/parse.y"
                         { expr_list_has_opt_comma = 1; }
#line 5525 "/build/zeek/src/zeek/build/src/p.cc"
    break;


#line 5529 "/build/zeek/src/zeek/build/src/p.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2348 "/build/zeek/src/zeek/src/parse.y"


int yyerror(const char msg[])
	{
	if ( in_debug )
		g_curr_debug_error = util::copy_string(msg);

	if ( last_tok[0] == '\n' )
		reporter->Error("%s, on previous line", msg);
	else if ( last_tok[0] == '\0' )
		{
		if ( last_filename )
			reporter->Error("%s, at end of file %s", msg, last_filename);
		else
			reporter->Error("%s, at end of file", msg);
		}
	else
		{
		if ( last_last_tok_filename && last_tok_filename &&
		     ! util::streq(last_last_tok_filename, last_tok_filename) )
			reporter->Error("%s, at or near \"%s\" or end of file %s",
			                      msg, last_tok, last_last_tok_filename);
		else
			reporter->Error("%s, at or near \"%s\"", msg, last_tok);
		}

	return 0;
	}
